package com.gct.aoid.algorithm;

/**
 * dec:
 * <p>
 * CardAreaAlgorithm
 * </p>
 *
 * @author lloyd
 * @version 1.0.1
 * @since 2022/4/24 下午6:45
 */
public class CardAreaAlgorithm {

    private static Double calAreaOfBlock(Double[] p1, Double[] p2) {
        double h = Math.abs(p1[0] - p2[0]);
        double Si = (p1[1] + p2[1]) * h / 2.0;
        return Si;
    }

    public enum CardDirection {
        up(1),
        down(-1);

        CardDirection(double i) {
            e = i;
        }

        private double e;

        public double getE() {
            return e;
        }
    }

    private static Double calOneWayArea(Double[][] gt, int start, int end, CardDirection direction, double si) {

        while (start != end) {
            int next = start + 1;
            if (next >= gt.length) {
                next = next - gt.length;
            }
            si += calAreaOfBlock(gt[start], gt[next]) * direction.getE();

            if (start + 1 >= gt.length) start -= gt.length;
            start++;
        }
        return si;
    }

    public static Double calArea(Double[][] gt) {

        int leftPosition = 0;
        int rightPosition = 0;
        Double[] leftPoint = gt[0];
        Double[] rightPoint = gt[0];
        for (int i = 1; i < gt.length; i++) {
            if (gt[i][0] < leftPoint[0]) {
                leftPoint = gt[i];
                leftPosition = i;
            } else if (gt[i][0] == leftPoint[0] && gt[i][1] <= leftPoint[1]) {
                leftPoint = gt[i];
                leftPosition = i;
            }

            if (gt[i][0] > rightPoint[0]) {
                rightPoint = gt[i];
                rightPosition = i;
            } else if (gt[i][0] == rightPoint[0] && gt[i][1] >= rightPoint[1]) {
                rightPoint = gt[i];
                rightPosition = i;
            }
        }
        double s = 0.0;
        s = calOneWayArea(gt, leftPosition, rightPosition, CardDirection.up, s);
        s = calOneWayArea(gt, rightPosition, leftPosition, CardDirection.down, s);
        return s;
    }
}
