package com.gct.aoid.controller;


import com.alibaba.fastjson.JSONObject;
import com.gct.aoid.entity.Vo.*;
import com.gct.aoid.service.AoidDailyYieldRefactorService;
import com.gct.aoid.service.AoidDailyYieldService;
import com.gct.aoid.service.LiqProdDailyCalService;
import com.gct.common.core.result.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author wh
 * @since 2023-11-23
 */
@Api(value = "AoidDailyYieldStatController", description = "量液相关接口")
@RestController
@RequestMapping("/aoidDailyYieldStat")
@Slf4j
public class AoidDailyYieldStatController {
    @Autowired
    private AoidDailyYieldRefactorService aoidDailyYieldRefactorService;


    @ApiOperation(value = "分组查询/单个 查询量液的统计信息" ,notes = "分组/单个 查询量液的统计信息")
    @PostMapping("/getAoidDailyYieldStat")
    public Result<AoidYeildStatVo> getAoidDailyYieldStat(@RequestBody AoidYeildVo aoidYeildVo){
        AoidYeildStatVo aoidYeildStatVo =   aoidDailyYieldRefactorService.getAoidDailyYieldStat(aoidYeildVo);
        return aoidYeildStatVo ==null?Result.error("未找到"):Result.ok(aoidYeildStatVo);
    }

    @ApiOperation(value = "分组查询 根据orgId和日期时间段查询产液量趋势" ,notes = "分组查询 根据orgId和日期时间段查询产液量趋势")
    @PostMapping("/getAoidDailyYieldStatTrend")
    public Result<List<AoidYeildStatTrendVo>> getAoidDailyYieldStatTrend(@RequestBody AoidYeildVo aoidYeildVo){
        List<AoidYeildStatTrendVo> aoidYeildStatTrendVoList =   aoidDailyYieldRefactorService.getAoidDailyYieldStatTrend(aoidYeildVo);
        return aoidYeildStatTrendVoList ==null?Result.error("未找到"):Result.ok(aoidYeildStatTrendVoList);
    }

    @ApiOperation(value = "分组查询 根据orgId和日期时间段查询错误工图趋势" ,notes = "分组查询 根据orgId和日期时间段查询错误工图趋势")
    @PostMapping("/getAoidDailyYieldStatErrorGtsTrend")
    public Result<List<AoidYeildErrorGtsTrendVo>> getAoidDailyYieldStatErrorGtsTrend(@RequestBody AoidYeildVo aoidYeildVo){
        List<AoidYeildErrorGtsTrendVo> aoidDailyYieldStatErrorGtsTrend =   aoidDailyYieldRefactorService.getAoidDailyYieldStatErrorGtsTrend(aoidYeildVo);
        return aoidDailyYieldStatErrorGtsTrend ==null?Result.error("未找到"):Result.ok(aoidDailyYieldStatErrorGtsTrend);
    }
    @ApiOperation(value = "分组查询 根据orgId和日期时间段查询量液异常趋势" ,notes = "分组查询 根据orgId和日期时间段查询量液异常趋势")
    @PostMapping("/getAoidDailyYieldAbnormalTrend")
    public Result<List<AoidYeildAbnormalTrendVo>> getAoidDailyYieldAbnormalTrend(@RequestBody AoidYeildVo aoidYeildVo){
        List<AoidYeildAbnormalTrendVo> aoidDailyYieldAbnormalTrend =   aoidDailyYieldRefactorService.getAoidDailyYieldAbnormalTrend(aoidYeildVo);
        return aoidDailyYieldAbnormalTrend ==null?Result.error("未找到"):Result.ok(aoidDailyYieldAbnormalTrend);
    }

    @ApiOperation(value = "分组查询 根据orgId和日期时间段查询错误工图占比" ,notes = "分组查询 根据orgId和日期时间段查询错误工图占比")
    @PostMapping("/getAoidDailyYieldStatErrorGtsBar")
    public Result<List<AoidYeildProportionBarVo>> getAoidDailyYieldStatErrorGtsBar(@RequestBody AoidYeildVo aoidYeildVo){
        List<AoidYeildProportionBarVo> aoidYeildProportionBarVos =   aoidDailyYieldRefactorService.getAoidDailyYieldStatErrorGtsBar(aoidYeildVo);
        return aoidYeildProportionBarVos ==null?Result.error("未找到"):Result.ok(aoidYeildProportionBarVos);
    }

    @ApiOperation(value = "分组查询 根据orgId和日期时间段查询量液异常占比" ,notes = "分组查询 根据orgId和日期时间段查询量液异常占比")
    @PostMapping("/getAoidDailyYieldAbnormalBar")
    public Result<List<AoidYeildProportionBarVo>> getAoidDailyYieldAbnormalBar(@RequestBody AoidYeildVo aoidYeildVo){
        List<AoidYeildProportionBarVo> aoidYeildProportionBarVos =   aoidDailyYieldRefactorService.getAoidDailyYieldAbnormalBar(aoidYeildVo);
        return aoidYeildProportionBarVos ==null?Result.error("未找到"):Result.ok(aoidYeildProportionBarVos);
    }

}

