package com.gct.aoid.controller;


import com.gct.aoid.entity.AoidGkHeavyModel;
import com.gct.aoid.service.AoidGkHeavyModelService;
import com.gct.aoid.service.AoidSinglewellheavyConfigService;
import com.gct.common.core.result.CodeMsgEnum;
import com.gct.common.core.result.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author Lloyd
 * @since 2021-01-31
 */
@RestController
@Api(value = "AoidGkHeavyModelController", description = "稠油模型参数维护接口--添加/修改/删除/分页查询")
@RequestMapping("/aoidGkHeavyModel")
public class AoidGkHeavyModelController {

    @Autowired
    AoidGkHeavyModelService aoidGkHeavyModelService;

    @Autowired
    AoidSinglewellheavyConfigService aoidSinglewellheavyConfigService;

    @ApiOperation(value = "selectOneByGKModel_HeavyByResultType(根据id查询稠油工况模型)", notes = "稠油模型参数数据")
    @GetMapping("/selectOneByGKModel_HeavyByResultType")
    public Result selectOneByGKModel_HeavyByResultType(@RequestParam("hid") @ApiParam("输入id") double hid) {
        return aoidGkHeavyModelService.selectOneByGKModel_HeavyByResultType(hid);
    }

    @ApiOperation(value = "selectGKresult(查询稠油诊断结果)", notes = "稠油模型参数数据")
    @GetMapping("/selectGKresult")
    public Result selectGKresult() {
        return aoidGkHeavyModelService.selectGKresult();
    }

    @ApiOperation(value = "selectGKodel(查询稠油模型数据)", notes = "查询稠油模型数据")
    @GetMapping("/selectGKodel")
    public Result selectGKodel() {
        return aoidSinglewellheavyConfigService.selectGKodel();
    }


    @ApiOperation(value = "addAoidGkHeavyModel(添加稠油模型参数数据)", notes = "添加稠油模型参数数据")
    @PostMapping("/addAoidGkHeavyModel")
    public Result addAoidGkHeavyModel(@RequestBody AoidGkHeavyModel aoidGkHeavyModel){
        return aoidGkHeavyModelService.addAoidGkHeavyModel(aoidGkHeavyModel);
    }

    @ApiOperation(value = "updateAoidGkHeavyModel(修改稠油模型参数数据)", notes = "修改稠油模型参数数据")
    @PostMapping("/updateAoidGkHeavyModel")
    public Result updateAoidGkHeavyModel(@RequestBody AoidGkHeavyModel aoidGkHeavyModel){
        return aoidGkHeavyModelService.updateAoidGkHeavyModel(aoidGkHeavyModel);
    }

    @ApiOperation(value = "deleteAoidGkHeavyModel(删除稠油模型参数数据)", notes = "删除稠油模型参数数据")
    @GetMapping("/deleteAoidGkHeavyModel")
    public Result deleteAoidGkHeavyModel(@RequestParam("hid") @ApiParam("输入id") Integer hid ){
        boolean removeById = aoidGkHeavyModelService.removeById(hid);
        return  removeById?Result.create(CodeMsgEnum.DELETE_SUCCESS):Result.create(CodeMsgEnum.DELETE_FAIL);
    }


    @ApiOperation(value = "findAllAoidGkHeavyModel(根据参数查询稠油模型参数数据--分页查询)", notes = "根据参数查询稠油模型参数数据")
    @GetMapping("/findAllAoidGkHeavyModel")
    public Result findAllAoidGkHeavyModel(
            @ApiParam(name = "pageNum",value = "当前页",required = true) @RequestParam("pageNum") Integer pageNum,
            @ApiParam(name = "pageSize",value = "页大小",required = true) @RequestParam("pageSize") Integer pageSize,
            @ApiParam(name = "result",value = "result") @RequestParam(value = "result",required = false) double result
    ){
        return aoidGkHeavyModelService.findAllAoidGkHeavyModel(pageNum,pageSize, result);
    }

}

