package com.gct.aoid.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.aoid.entity.Vo.AoidYeildVo;
import com.gct.aoid.job.TimingSummaryJob;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.aoid.service.impl.calDiagramProductionCorrectService;
import com.gct.common.core.result.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.lang.reflect.InvocationTargetException;
import java.text.ParseException;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author 王森玉
 * @since 2021-01-31
 */
@Api(value = "calDiagramProductionCorrectController", description = "量液参数")
@RestController
//@ResponseBody
@RequestMapping("/calDiagramProductionCorrect")

public class CalDiagramProductionCorrectController {


    @Autowired
    private com.gct.aoid.service.impl.calDiagramProductionCorrectService calDiagramProductionCorrectService;
    public static AtomicInteger atomicInteger = new AtomicInteger(0);

    @ApiOperation(value = "findparameter(根据参数进行系数重新计算)", notes = "根据参数进行系数重新计算")
    @GetMapping("/findparameter")
    public void findparameter(
            @ApiParam(name = "datetime",value = "时间") @RequestParam("datetime") String datetime,
            @ApiParam(name = "org_id",value = "组织Id") @RequestParam("org_id") String org_id,
            @ApiParam(name = "wellid",value = "井号") @RequestParam("wellid") String wellid
    ) throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException {

        if (atomicInteger.get()!=0) {
            return;
        }

        ExecutorService pool = Executors.newSingleThreadExecutor();
        pool.execute(new Runnable() {
            @SneakyThrows
            @Override
            public void run() {
                atomicInteger.set(2);
                calDiagramProductionCorrectService.parametercalculation(datetime,org_id, wellid);  // 0 没有计算任务 1 计算完成  2 计算中
                atomicInteger.set(1);
            }
        });

    }
    @ApiOperation(value = "findparameter(查看重新计算的进度)", notes = "查看重新计算的进度")
    @GetMapping("/getParamCalTaskExecutor")
    public Result getParamCalTaskExecutor (){
        int i = atomicInteger.get();
        if (i==1){
            atomicInteger.set(0);
        }
        return Result.ok(i);
    }



}

