package com.gct.aoid.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.gct.aoid.config.LocalDateTimeConverter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 产量检索表
 * </p>
 *
 * @author gxt
 * @since 2022-10-24
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="AoidProductRetrieval对象", description="产量检索表")
@TableName("aoid.aoid_product_retrieval")
public class AoidProductRetrieval extends Model<AoidProductRetrieval> {

    private static final long serialVersionUID=1L;

    @TableId(value = "ID",type = IdType.ASSIGN_UUID)
    @ExcelIgnore
    private String id;

    @ApiModelProperty(value = "作业区")
    @ExcelProperty(value = "作业区", index = 0)
    private String workArea;

    @ApiModelProperty(value = "井号")
    @ExcelProperty(value = "井号", index = 1)
    private String wellId;

    @ApiModelProperty(value = "计产日期")
    @ExcelProperty(value = "计产日期", index = 2,converter = LocalDateTimeConverter.class)
    private LocalDateTime prodDate;

    @ApiModelProperty(value = "系统值")
    @ExcelProperty(value = "系统值", index = 3)
    private Double systemVal;

    @ApiModelProperty(value = "系统总值")
    @ExcelProperty(value = "系统总值", index = 4)
    private Double systemTotalVal;

    @ApiModelProperty(value = "人工测定值")
    @ExcelProperty(value = "人工测定值", index = 5)
    private Double determineVal;

    @ApiModelProperty(value = "计量方式")
    @ExcelProperty(value = "计量方式", index = 6)
    private String determineMode;

    @ApiModelProperty(value = "制度类型(控液井,间开井,加药井)")
    @ExcelProperty(value = "制度类型", index = 7)
    private String wellSystem;

    @ApiModelProperty(value = "井下结构(默认直井,水平井,浅井,喷抽井)")
    @ExcelProperty(value = "井下结构", index = 8)
    private String downHoleStructure;

    @ApiModelProperty(value = "泵类型(杆式柱塞泵,螺杆泵,电浅泵,无泵)")
    @ExcelProperty(value = "泵类型", index = 9)
    private String pumpType;

    @ApiModelProperty(value = "抽油机类型(游梁式,塔式)")
    @ExcelProperty(value = "抽油机类型", index = 10)
    private String oilMachineType;

    @ApiModelProperty(value = "当前误差")
    @ExcelProperty(value = "当前误差", index = 11)
    private Double currentError;

    @ApiModelProperty(value = "允许误差")
    @ExcelProperty(value = "允许误差", index = 12)
    private Double allowableError;

    @ApiModelProperty(value = "评估")
    @ExcelProperty(value = "评估", index = 13)
    private String assessment;

    @ApiModelProperty(value = "原因")
    @ExcelProperty(value = "原因", index = 14)
    private String reason;

    @ApiModelProperty(value = "根据接入表查询是否接入")
    @ExcelProperty(value = "是否接入", index = 15)
    private String accessMessage;

    @ApiModelProperty(value = "是否合并计量")
    @ExcelIgnore
    private Integer isSummary;

    @Override
    protected Serializable pkVal() {
        return null;
    }

}
