package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * class name: ProDataForCalProduction
 * <p>
 * 甲方生产库数据
 * 为了计算产量数据
 * </p>
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/2/4 下午3:09
 */
@Data
@Accessors(chain = true)
public class ProDataForCalProduction {
    @TableField("wellId")
    private String jh;
    @TableField("oilNozzle")
    private Double bj;
    @TableField("pumpDepth")
    private Double bs;
    /*
    %
     */
    @TableField("waterCut")
    private Double hsl;
    @TableField("gasOilRatio")
    private Double qyb;
    @TableField("startPumpLiqLevel")
    private Double dym;
    @TableField("surfaceCrudeOilDensity")
    private Double ymd;
    @TableField("surfaceCrudeWaterDensity")
    private Double smd;
    @TableField("prodDate")
    private String proDate;


    private Double backPres;
    private Double tubingPres;
    private Double casingPres;

    @TableField("submergenceDepth")
    private Double cmd;

    private Double liqProdDaily;
    private Double oilProdDaily;
    private Double waterProdDaily;
    private Double gasProdDaily;

    private String remarks;
    private Integer prodTime;


    @TableField("viscosity")
    private double nd;

    @TableField("coefficient")
    private double pzxs;

    @TableField("ismatching")
    private String ismatching;

    @TableField("testLiquVolDaily")
    private Double tlvd;
}
