package com.gct.aoid.entity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * class name: WellAttr
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/8/6 上午11:01 Fri
 */
@Data
public class WellAttr {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "井ID")
    private String wellId;


    @ApiModelProperty(value = "机构ID;")
    private String orgId;

    @ApiModelProperty(value = "开采层系ID")
    private String producingZoneId;

    @ApiModelProperty(value = "开发井网ID")
    private String devPattternId;

    @ApiModelProperty(value = "油品分类")
    private String oilProductsSorting;

    @ApiModelProperty(value = "量油方式")
    private String testType;

    @ApiModelProperty(value = "量油常数")
    private String prodMeterCons;

    @ApiModelProperty(value = "投产措施;投产时的措施，0：无措施正常投产，1：压力投产，2：酸化投产")
    private Integer startProdStitum;

    @ApiModelProperty(value = "采油方式")
    private String oilProductionMethod;

    @ApiModelProperty(value = "注入方式")
    private String injectionMethod;

    @ApiModelProperty(value = "工作制度;工作制度，提捞井的需求，填写提捞周期")
    private String jobSystem;

    @ApiModelProperty(value = "投产日期")
    private LocalDateTime prodDate;

    @ApiModelProperty(value = "气油比;计算产气量用  m^3/t")
    private Double gasOilRatio;

    @ApiModelProperty(value = "水气比  t/10^4m^3")
    private Double waterGasRatio;

    @ApiModelProperty(value = "报废原因")
    private String abandonReason;

    @ApiModelProperty(value = "报废方式")
    private String abandonType;

    @ApiModelProperty(value = "井底真垂直深度")
    private Double bhTvd;

    @ApiModelProperty(value = "井底测深")
    private Double bhMd;

    @ApiModelProperty(value = "是否是斜井，填写Y或N")
    private String isDeviated;

    @ApiModelProperty(value = "井身质量")
    private String endStatus;

    @ApiModelProperty(value = "井口粘度")
    private Double viscosity;

    @ApiModelProperty(value = "膨胀系数")
    private Double coefficient;

    @ApiModelProperty(value = "是否匹配")
    private String ismatching;

    @ApiModelProperty(value = "更新时间")
    private String updateTime;

    @ApiModelProperty(value = "标记人")
    private String markedBy;

    @ApiModelProperty(value = "标定参数说明")
    private String markedParmExplain;
}

