package com.gct.aoid.job.statusEnum;

/**
 * enum name: JobStatusEnum
 *
 * @author gxt
 * @version 1.0
 * @since 2021/8/12 下午5:41 周四
 */
public enum JobStatusEnum {
   HAVE_NOT_STARTED(0,"未启动"),
   NORMAL(1,"正常"),
   PAUSE(2,"暂停"),
   RUNTIME_OUT_EXCEPTION(3,"运行超时异常");


   private final int status;
   private final String desc;

   JobStatusEnum(int status, String desc) {
      this.status = status;
      this.desc = desc;
   }

   public int getStatus() {
      return status;
   }

   public String getDesc() {
      return desc;
   }
   public static String getDesc(int status) {
      for (JobStatusEnum statusEnum : JobStatusEnum.values()){
         if (statusEnum.getStatus() == status) return statusEnum.getDesc();
      }
      return null;
   }


}
