package com.gct.aoid.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.gct.aoid.entity.AoidGkHeavyModel;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author Lloyd
 * @since 2021-01-31
 */
@Mapper
public interface AoidGkHeavyModelMapper extends BaseMapper<AoidGkHeavyModel> {


    /**
     * 根据id结果查询模型
     * @param hid
     * @return
     */
    AoidGkHeavyModel selectOneByGKModel_HeavyByResultType(@Param("hid") double hid);

    /**
     * 根据工况结果查询模型
     * @param result
     * @return
     */
    AoidGkHeavyModel selectOneByGKModel_HeavyByResultType1(@Param("result") String result);


    /**
     * 根据工况结果查询模型相关数据
     * @param page
     * @param result
     * @return
     */
    IPage<AoidGkHeavyModel> findAllAoidGkHeavyModel(IPage<?> page,
                                                     @Param("hid") double result);
}
