package com.gct.aoid.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author Lloyd
 * @since 2021-01-31
 */
@Mapper
public interface AoidSinglegtYieldMapper extends BaseMapper<AoidSinglegtYield> {

    List<AoidSinglegtYield> findByJh(@Param("jh") String jh);

    List<AoidSinglegtYield> findByJhbase(@Param("jh") String jh,@Param("start") String start,@Param("end") String end);

    List<AoidSinglegtYield> findByJhbaseLy(@Param("jh") String jh,@Param("start") String start,@Param("end") String end);//用于量液

    List<AoidSinglegtYield> findByJhbaseLyZdjg(@Param("jh") String jh,@Param("start") String start,@Param("end") String end);//用于量液

    List<AoidSinglegtYield> findByJhbasecs(@Param("jh") String jh,@Param("start") String start,@Param("end") String end);

    List<AoidSinglegtYield> findByJhhssyl(@Param("jh") String jh);


    List<AoidSinglegtYield> getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod(@Param("wellId") String wellId,
                                                                             @Param("startDate") String startDate);

    List<AoidSinglegtYield> getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodAndPages(@Param("wellId") String wellId,
                                                                                     @Param("startDate") String startDate,
                                                                                     @Param("endDate") String endDate,
                                                                                     @Param("page") int page,
                                                                                     @Param("size") int size);

    List<AoidSinglegtYield> selectWellIdList(@Param("date") LocalDateTime date);

    /**
     * 根据参数条件进行功图浏览(组织最新一条)
     * @param page
     * @param well_id
     * @param beginTime
     * @param endTime
     * @return
     */
    IPage<AoidSinglegtYield> getCvrresultByTime_brow(IPage<?> page,
                                                   @Param("well_id") List<String> well_id,
                                                   @Param("beginTime") String beginTime,
                                                   @Param("endTime") String endTime);

    /**
     * 根据参数条件进行功图浏览(井号全部)
     * @param page
     * @param well_id
     * @param beginTime
     * @param endTime
     * @return
     */
    IPage<AoidSinglegtYield> getCvrresultByTime_brow_wellid(IPage<?> page,
                                                          @Param("well_id") String well_id,
                                                          @Param("beginTime") String beginTime,
                                                          @Param("endTime") String endTime);

    /**
     * 根据参数条件
     * @param page
     * @param well_id
     * @param beginTime
     * @param endTime
     * @return
     */
    IPage<AoidSinglegtYield> getCvrresultByTime_brow_wellidSgtIsLegal(IPage<?> page,
                                                            @Param("well_id") String well_id,
                                                            @Param("beginTime") String beginTime,
                                                            @Param("endTime") String endTime,
                                                            @Param("sgtIsLegal") Integer sgtIsLegal);


    List<AoidSinglegtYield> selectAoidSinglegtYieldYesterday(@Param("beginTime") String beginTime,@Param("endTime") String endTime);




}
