package com.gct.aoid.rocketmq;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;

@Data
public class AoidMsg {
    BaseParam baseParam;
    DiagnoseResult diagnoseResult;


    @Data
    public static class BaseParam {
        private Double sAtSlopeMinLoc;
        private Double sAtSlopeMaxLoc;
        private Double slopeDownloadMin;
        private Double slopeDownloadMax;

        private String id;

        private LocalDateTime createtime;

        private LocalDateTime prodDate;

        private String wellname;

        private String wellId;

        private String sgt;

        private double sMax;

        private double sMin;

        private Double lMax;

        private Double lMin;

        private double s;

        private double n;

        private double l;

        private double sEffect;

        private double area;

        private double upload;

        private double download;

        private Integer islegal;

        private String remark;

        private double lMid;

        private double lFirstdownturnpoint;

        private double sPre;

        private Integer sgtpointnum;

        private Integer sMaxPointLocation;

        private Integer sMinPointLocation;

        private Integer lMaxPointLocation;

        private Integer lMinPointLocation;

    }

    @Data
    public static class DiagnoseResult {

        @ApiModelProperty(value = "id")
        private String id;

        @ApiModelProperty(value = "一次诊断结果")
        private String result1;

        @ApiModelProperty(value = "专家经验公式诊断结果")
        private String result2;

        @ApiModelProperty(value = "井号")
        private String wellId;

        @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
        private LocalDateTime prodDateTime;

        @ApiModelProperty(value = "示功图")
        private String sgt;

        @ApiModelProperty(value = "备注")
        private String remark;


    }
}
