package com.gct.aoid.service;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.entity.Vo.AoidYeildVo;
import com.gct.aoid.entity.Vo.LiqWarringVo;
import com.gct.common.core.result.Result;

import java.lang.reflect.InvocationTargetException;
import java.text.ParseException;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author Jyx
 * @since 2021-01-28
 */
public interface AoidDailyYieldService extends IService<AoidDailyYield> {

    /**
     * 单井历史产量曲线/柱状图
     *
     * @param wellName 井号
     * @param beginDate 开始时间
     * @param endDate 截止时间
     * @return
     */
    Result getSingleHistoryYieldCurveOrChart(String wellName, String beginDate, String endDate,String bs);

   // List<Map<String, Object>> getAoidDailyYieldInfoByWellIdAndPorDatePeriod(String wellId, String startDate);
    List<AoidDailyYield> getAoidDailyYieldInfoList(String wellId, String startDate,String endDate);


    List<String> getWellIds(String org, String wellId);
    List<String> getWellIdsByNew(String org, String wellId, LocalDateTime startDate);

    // Page<Map<String, Object>> getAoidDailyYieldInfoByWellIdAndPorDatePeriodByPage(String org, String wellId, String startDate, int pageSize, int pageNum);
    Page<AoidDailyYield> getAoidDailyYieldInfoByWellIdAndPorDatePeriodByPage(String org, String wellId, String startDate, String endDate,int pageSize, int pageNum);

    AoidDailyYield getDefaultData();

 List<AoidDailyYield> getDefaultDataNew(String orgId);

    Page<AoidDailyYield> getAoidDailyYieldInfoPage(AoidYeildVo aoidYeildVo);

    //List<AoidDailyYield> exportExcel(AoidYeildVo aoidYeildVo);

    JSONObject getAllMeasureInfo(Integer bs,String orgId, String wellId, String startDate, String endDate, Integer page, Integer size, String wellIdSet);


    /**
     * 查询量液汇总数据（针对A2为0不作参考）
     * @param jh
     * @return
     */
     List<AoidDailyYield> findByJhAoidDailyA2(String jh,String prodDate);


    JSONObject exportExcel(Integer bs ,String orgId, String wellId, String startDate, String endDate, String wellIdSet);


    List<Map<String, Object>> getAoidLiqProdDailyForSevenDay();

    Map<String, Object> getLiqWarring(LiqWarringVo liqWarringVo);

    Object getCalErrorRateByDate(JSONObject jsonObject) throws ParseException;


    Object getCalErrorRateDiagram(JSONObject jsonObject);

    List<Map<String, Object>> getLiqDailyYestAndTenAndMonth(LocalDateTime prodDate);

    /**
     * 实时查询前一天量液汇总的数据
     * @param jh
     * @return
     */
    List<AoidDailyYield> findByJhAoidDaily(String jh, String start, String end);

    List<AoidDailyYield> getCalErrorRateByDateToday(String date);

    /**
     * 分页查询误差率详细井号
     * @param pageNum
     * @param pageSize
     * @param zyq
     * @param wcStart
     * @param wcEnd
     * @param cylStart
     * @param cylEnd
     * @param dateStart
     * @param dateEnd
     * @return
     */
    IPage<AoidDailyYield> findWellWc(Integer pageNum, Integer pageSize, String zyq, String wcStart,String wcEnd, String cylStart, String cylEnd,String jh,String  dateStart,String dateEnd);


    void calculateProdDateData(String well,String[] orgs , String startDate, String endDate , String startTimeEveryDay) throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException;

}
