package com.gct.aoid.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.entity.WellAttr;
import com.gct.common.core.result.Result;

import java.lang.reflect.InvocationTargetException;
import java.text.ParseException;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author 王森玉
 * @since 2021-01-31
 */
public interface AoidSinglegtYieldService extends IService<AoidSinglegtYield> {

    /**
     * 量液--功图平铺
     * Author:王森玉
     * @param pageNum
     * @param pageSize
     * @param jh
     * @return
     */

    Result findAoidSinglegtYieldByPages(Integer pageNum, Integer pageSize, String jh);


    List<AoidSinglegtYield> findByJh(String jh);

    /**
     * 实时查询前一天单张功图液量信息数据（定时运行任务）
     * @param jh
     * @return
     */
    List<AoidSinglegtYield> findByJhbase(String jh,String start,String end);


    /**
     * 实时查询前一天单张功图液量信息数据（用于量液分析）
     * @param jh
     * @return
     */
    List<AoidSinglegtYield> findByJhbaseLy(String jh,String start,String end);


    /**
     * 实时查询前一天单张功图液量信息数据（用于量液分析--诊断结果）
     * @param jh
     * @return
     */
    List<AoidSinglegtYield> findByJhbaseLyZdjg(String jh,String start,String end);

    /**
     * 实时查询前一天单张功图液量信息数据（指定参数运行）
     * @param jh
     * @return
     */
    List<AoidSinglegtYield> findByJhbasecs(String jh,String start,String end);

    List<Map<String, Object>> getAoidSinglegtYieldListByOneDay(String wellId, String date);

    List<Map<String, Object>> getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod(String wellId, String startDate);
    List<AoidSinglegtYield> getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod(String wellId, String start, String end);

    List<AoidSinglegtYield> getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod(String wellId, LocalDateTime start, LocalDateTime end);

    List<AoidSinglegtYield> getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodNew(List<String> wellId, LocalDateTime start, LocalDateTime end);

    Page<Map<String,Object>> getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodAndPages(String wellId, String startDate, String endDate, int page, int size) throws ParseException;


    List<AoidSinglegtYield> getAoidSinglegtYieldInfogk(String wellId);

    Page<AoidSinglegtYield> getResultIdByWellId(String wellId, String date, boolean isOnlyShowErrorGt,int pageSize,int pageNum);


    /**
     * 根据参数条件进行功图浏览
     * @param beginTime
     * @param endTime
     * @param orgid
     * @param wellId
     * @param pageNum
     * @param pageSize
     * @return
     */
    IPage<AoidSinglegtYield> getCvrresultByTimeBrowSingle(String beginTime, String endTime, String orgid, String wellId,Integer sgtIsLegal, Integer pageNum, Integer pageSize);


    /**
     * 针对间开井查询最新时间
     * @param wellId
     * @return
     */
    List<AoidSinglegtYield> getAoidSinglegtYieldMaxProdate(String wellId);

    /**
     * 针对A2液量频繁变化查询最新膨胀系数更新时间
     * @param wellId
     * @return
     */
    AoidSinglegtYield getAoidSinglegtYieldMaxUpdateTime(String wellId);


    /**
     * 添加单井属性信息
     * @param wellAttr
     * @return
     */
    void addCbPcDevWellAttr(WellAttr wellAttr) throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException;

    Double getA2Basedata(String wellId, String A2ProdDate)throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException;

    Object getOverlayPaging(Integer pageNum, Integer pageSize, String wellId, String beginTime, String endTime);

    Page<AoidSinglegtYield> getCvrresultByTime(String beginTime, String endTime, String wellId, Integer pageNum, Integer pageSize);
}
