package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.gct.aoid.algorithm.*;
import com.gct.aoid.entity.*;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.feignclient.DiagnoseClient;
import com.gct.aoid.rocketmq.AoidMsg;
import com.gct.aoid.service.*;
import com.gct.common.core.result.Result;
import com.gct.common.util.SGTUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.lang.reflect.InvocationTargetException;
import java.text.DecimalFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;

/**
 * class name: CalDiagramProductionService
 *
 * @author lloyd
 * @version 1.0
 * @explain 量液服务类
 * @since 2021/1/29 下午9:47
 */
@Component
@Slf4j
public class CalDiagramProductionService {

    @Autowired
    private AoidCalprotaskqueueService aoidCalprotaskqueueService;
    @Autowired
    private BaseDataClient baseDataClient;
    @Autowired
    private DiagnoseClient diagnoseClient;
    @Autowired
    private AoidGkModelService aoidGkModelService;
    @Autowired
    private AoidGkHeavyModelService aoidGkHeavyModelService;
    @Autowired
    private AoidSinglewellConfigService aoidSinglewellConfigService;
    @Autowired
    private CalPumpCard calPumpCard;
    @Autowired
    private CalDiagramProduction calDiagramProduction;
    @Autowired
    private AoidSinglegtYieldService aoidSinglegtYieldService;
    @Autowired
    private AoidDailyYieldService aoidDailyYieldService;

    private final DateTimeFormatter dfValue = DateTimeFormatter.ofPattern("yyyy-MM-dd");
    private final DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
    private final DateTimeFormatter formatterDate = DateTimeFormatter.ofPattern("yyyy-MM-dd");
    private final DateTimeFormatter formatterDateTime = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
    private final String time0 = "16:00:00";

    String num0Parm = "参数稳定";
    String num1Parm = "有效冲程上升/下降，载荷稳定，面积稳定------取有效冲程";
    String num2Parm = "有效冲程上升，载荷稳定，面积上升------取有效冲程";
    String num3Parm = "有效冲程稳定，载荷稳定，面积上升/下降------取面积";
    String num4Parm = "有效冲程上升，载荷上升，面积上升------取有效冲程";
    String num5Parm = "有效冲程稳定，载荷上升，面积稳定------算作稳定";
    String num6Parm = "有效冲程下降，载荷稳定，面积下降------取有效冲程";
    String num7Parm = "有效冲程上升，载荷下降，面积下降------取面积";
    String num8Parm = "有效冲程稳定，载荷下降，面积下降------取面积";
    String num9Parm = "有效冲程下降，载荷下降，面积下降------取有效冲程";
    String num10Parm = "有效冲程下降，载荷上升，面积上升------取有效冲程";
    String num11Parm = "有效冲程下降，载荷上升，面积下降-----取有效冲程";
    String num12Parm = "有效冲程下降，载荷稳定，面积上升----取面积";
    String num13Parm = "有效冲程上升，载荷稳定，面积下降---取面积";
    String num14Parm = "有效冲程上升,载荷上升,面积下降---取面积";
    String num15Parm = "有效冲程上升,载荷上升,面积稳定---取有效冲程";
    String num16Parm = "有效冲程上升,载荷下降,面积上升---取有效冲程";
    String num17Parm = "有效冲程上升,载荷下降,面积稳定---取有效冲程";
    String num18Parm = "有效冲程下降,载荷上升,面积稳定---取有效冲程";
    String num19Parm = "有效冲程下降,载荷下降,面积上升---取面积";
    String num20Parm = "有效冲程下降,载荷下降,面积稳定---取有效冲程";
    String num21Parm = "有效冲程稳定,载荷上升,面积上升---取面积";
    String num22Parm = "有效冲程稳定,载荷上升,面积下降---取面积";
    String num23Parm = "有效冲程稳定,载荷下降,面积稳定---取有效冲程";
    String num24Parm = "有效冲程稳定-载荷差下降-面积上升-----取面积";
    String num25Parm = "有效冲程下降，载荷差下降，面积稳定-----算作稳定";
    String num26Parm = "有效冲程稳定，载荷差下降，面积稳定-----算作稳定";
    final static String num27Param = "热洗井筒影响期";

    //量液入口
    public void calWrapper(AoidMsg msg) throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException {
        if (Objects.isNull(msg)) log.warn("Not supported msg content :null");
        AoidMsg.BaseParam baseParam = msg.getBaseParam();
        if (Objects.nonNull(baseParam) && Objects.nonNull(baseParam.getProdDate()) &&
                Objects.nonNull(baseParam.getWellId())) {
            String oneStr = baseDataClient.selectOneByWellId(baseParam.getWellId());
            Result result = JSONObject.parseObject(oneStr, Result.class);
            if (result.getData() != null) {
                WellAttr o = JSONObject.toJavaObject((JSONObject) JSONObject.toJSON(result.getData()), WellAttr.class);
                if ("2".equals(o.getOilProductsSorting())) {
                    /**
                     * 稠油
                     */
                    cal2(msg);
                    return;
                } else if ("1".equals(o.getOilProductsSorting())) {
                    /**
                     * 稀油
                     */
                    cal(msg);
                    return;
                }
            }
            cal(msg);
        }
        cal(msg);
    }


    //稀油量液计算
    public void cal(AoidMsg msg) throws InstantiationException, IllegalAccessException, InvocationTargetException, NoSuchMethodException {

        AoidMsg.BaseParam baseParam = msg.getBaseParam();
        DynamicParam dynamicParamOriginal = null;
        String dateStartCoefficient = null;
        String dateEndCoefficient = null;
        String updateNew = null;

        double xs = 0.0;

        String realDate = null;
        LocalDateTime nowValue = LocalDateTime.parse(baseParam.getProdDate().format(formatterDate) + " " + time0, formatterDateTime);


        if (baseParam.getProdDate().isBefore(nowValue)) {
            realDate = msg.getBaseParam().getProdDate().format(dfValue) + " 00:00:00";
        } else {
            realDate = msg.getBaseParam().getProdDate().plusDays(1).format(dfValue) + " 00:00:00";
        }


        String calibrationList = baseDataClient.getCbPcDevWellAttrMaxUpdateTime(baseParam.getWellId(), realDate, "2");
        Result calibrationListresult = JSONObject.parseObject(calibrationList, Result.class);
        Object calibrationObject = calibrationListresult.getData();
        if (calibrationObject != null) {
            JSONObject calibrationListjson = JSONObject.parseObject(calibrationListresult.getData().toString());
            if (calibrationListjson.size() > 0) {
                updateNew = calibrationListjson.getString("updateTime").split("\\.")[0];
                dateStartCoefficient = LocalDateTime.parse(updateNew, df).minusDays(2).format(dfValue) + " 16:00:00";
                dateEndCoefficient = LocalDateTime.parse(updateNew, df).minusDays(1).format(dfValue) + " 16:00:00";
                String calibrationListXs = baseDataClient.getCbPcDevWellAttrMaxUpdateTime(baseParam.getWellId(), LocalDateTime.parse(updateNew, df).format(df), "3");
                Result calibrationListresultXs = JSONObject.parseObject(calibrationListXs, Result.class);
                JSONObject calibrationListjsonXs = JSONObject.parseObject(calibrationListresultXs.getData().toString());
                String markedBy = calibrationListjsonXs.getString("markedBy");

                if (markedBy.equals("系统自动")) {
                    dynamicParamOriginal = getDynamicParam(baseParam.getWellId(), dateStartCoefficient, dateEndCoefficient);
                    if (dynamicParamOriginal.stroke != null && dynamicParamOriginal.frequence != null) {
                        double difStroke = Math.abs(baseParam.getS() - dynamicParamOriginal.stroke);
                        double difFrequence = Math.abs(baseParam.getN() - dynamicParamOriginal.frequence);
                        if (difStroke > 0.5 || difFrequence > 0.5) {
                            String calibrationListParam = baseDataClient.getCbPcDevWellAttrMaxUpdateTime(baseParam.getWellId(), updateNew, "2");
                            Result calibrationListresultParam = JSONObject.parseObject(calibrationListParam, Result.class);
                            Object calibrationObjectParam = calibrationListresultParam.getData();
                            if (calibrationObjectParam != null) {
                                JSONObject calibrationListjsonParam = JSONObject.parseObject(calibrationObjectParam.toString());
                                if (calibrationListjsonParam.size() > 0) {
                                    String updateNewParm = calibrationListjsonParam.getString("updateTime").split("\\.")[0];
                                    String dateStartCoefficientParm = LocalDateTime.parse(updateNewParm, df).minusDays(2).format(dfValue) + " 16:00:00";
                                    String dateEndCoefficientParm = LocalDateTime.parse(updateNewParm, df).minusDays(1).format(dfValue) + " 16:00:00";
                                    xs = calibrationListjsonXs.getDouble("coefficient").doubleValue();

                                    calAccordingCoefficient(msg, baseParam.getWellId(), dateStartCoefficientParm, dateEndCoefficientParm,
                                            LocalDateTime.parse(updateNewParm, df).format(dfValue), xs);
                                }
                            } else {
                                calEnd(msg, 1.0, 0, 0, null, 0,
                                        0, 0, 0, 0, 0,
                                        0, 0, null, null, null, null);
                            }
                        } else {
                            xs = calibrationListjsonXs.getDouble("coefficient").doubleValue();
                            calAccordingCoefficient(msg, baseParam.getWellId(), dateStartCoefficient, dateEndCoefficient,
                                    LocalDateTime.parse(updateNew, df).format(dfValue), xs);
                        }

                    } else {
                        xs = calibrationListjsonXs.getDouble("coefficient").doubleValue();
                        calAccordingCoefficient(msg, baseParam.getWellId(), dateStartCoefficient, dateEndCoefficient,
                                LocalDateTime.parse(updateNew, df).format(dfValue), xs);
                    }
                } else {
                    xs = calibrationListjsonXs.getDouble("coefficient").doubleValue();
                    calEnd(msg, xs, 0, 0, null, 0,
                            0, 0, 0, 0, 0,
                            0, 0, null, null, null, null);
                }


            }
        } else {
            calEnd(msg, 1.0, 0, 0, null, 0,
                    0, 0, 0, 0, 0,
                    0, 0, null, null, null, null);
        }


    }

    //根据最近一次产量标定推测面积系数
    public void calAccordingCoefficient(AoidMsg msg, String wellId, String dateStart, String dateEnd,
                                        String A2prodDate, double xs) throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException {


        AoidMsg.BaseParam baseParam = msg.getBaseParam();
        AoidMsg.DiagnoseResult diagnoseResult = msg.getDiagnoseResult();
        Double[][] sgt = baseParam.getSgt() == null ? null : SGTUtil.encodeToDoubleArray(baseParam.getSgt());
        double areaReal = CardAreaAlgorithm.calArea(sgt);
        AoidSinglegtYieldReal aoidSinglegtYieldReal = null;
        double bdxs = 0.0;
        double AreaOriginal = 0.0;
        double YxccOriginal = 0.0;
        double BdxsOriginal = 0.0;
        double LoadDifferenceOriginal = 0.0;
        String flag = null;
        DynamicParam dynamicParamOriginal = null;
        String A2prodDateValue = A2prodDate + " 00:00:00";
        String dateStartLiq = null;
        String dateEndLiq = null;

        A2Basedata a2BasedataOriginal = getA2Basedata(wellId, A2prodDateValue);

        dynamicParamOriginal = getDynamicParam(wellId, dateStart, dateEnd);


        LocalDateTime nowValue = LocalDateTime.parse(baseParam.getProdDate().format(formatterDate) + " " + time0, formatterDateTime);

        if (baseParam.getProdDate().isBefore(nowValue)) {
            dateStartLiq = baseParam.getProdDate().plusDays(-1).format(dfValue) + " 16:00:00";
            dateEndLiq = baseParam.getProdDate().format(dfValue) + " 16:00:00";
        } else {
            dateStartLiq = baseParam.getProdDate().format(dfValue) + " 16:00:00";
            dateEndLiq = baseParam.getProdDate().plusDays(+1).format(dfValue) + " 16:00:00";
        }

        List<AoidSinglegtYield> resultLiq = aoidSinglegtYieldService.findByJhbasecs(wellId, dateStartLiq, dateEndLiq);

        if (diagnoseResult.getResult1().equals("-1")) {
            calEnd(msg, 1.0, 0, 0, null, 0,
                    0, 0, 0, 0, 0,
                    0, 0, null, null, null, null);
        } else if (areaReal <= -1 || areaReal > 500) {
            calEnd(msg, 1.0, 0, 0, null, 0,
                    0, 0, 0, 0, 0,
                    0, 0, null, null, null, null);
        } else {
            String isStop = null;

            isStop = "否";
            AreaOriginal = (dynamicParamOriginal.area == null) ? 0 : dynamicParamOriginal.area;
            YxccOriginal = (dynamicParamOriginal.yxcc == null) ? 0 : dynamicParamOriginal.yxcc;
            BdxsOriginal = xs;
            LoadDifferenceOriginal = (dynamicParamOriginal.LoadDifference == null) ? 0 : dynamicParamOriginal.LoadDifference;

            if (resultLiq.size() >= 1) {
                bdxs = resultLiq.get(resultLiq.size() - 1).getBdxs();
            } else {
                bdxs = BdxsOriginal;
            }


            if (a2BasedataOriginal.bj != null) {
                aoidSinglegtYieldReal = calreal(sgt, baseParam.getS(), baseParam.getN(),
                        baseParam.getIslegal(), diagnoseResult.getResult2(), a2BasedataOriginal.bj, a2BasedataOriginal.bs,
                        a2BasedataOriginal.hsl, a2BasedataOriginal.smd, a2BasedataOriginal.ymd, a2BasedataOriginal.qyb, a2BasedataOriginal.dym, bdxs);
                if (aoidSinglegtYieldReal.yxcc != null && aoidSinglegtYieldReal.rcl != null) {
                    ConjectureRcyl(a2BasedataOriginal.LiqProdDaily, YxccOriginal, aoidSinglegtYieldReal.yxcc, aoidSinglegtYieldReal.rcl,
                            LoadDifferenceOriginal, baseParam.getLMax(), baseParam.getLMin(), AreaOriginal, areaReal, msg, bdxs,
                            baseParam.getWellId(), sgt, baseParam.getS(), baseParam.getN(), baseParam.getIslegal(), diagnoseResult.getResult2(), a2BasedataOriginal.bj, a2BasedataOriginal.bs,
                            a2BasedataOriginal.hsl, a2BasedataOriginal.smd, a2BasedataOriginal.ymd, a2BasedataOriginal.qyb, a2BasedataOriginal.dym, isStop, A2prodDateValue, BdxsOriginal);
                }
            } else {
                calEnd(msg, 1.0, 0, 0, null, 0,
                        0, 0, 0, 0, 0,
                        0, 0, null, null, "无标定信息", null);
            }


        }

    }

    //获取A2基础数据
    public A2Basedata getA2Basedata(String wellId, String A2ProdDate) throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException {


        A2Basedata a2Basedata = new A2Basedata();
        ProDataForCalProduction a2DataVolYesterday;
        ProDataForCalProduction a2DataStatusYesterday;
        String a2dataStrVolYesterday = null;
        String a2dataStrYesterday = null;

        a2dataStrVolYesterday = baseDataClient.getA2VolDataForCalProduction(wellId, A2ProdDate);
        a2DataVolYesterday = (ProDataForCalProduction) JSONObject.parseObject(a2dataStrVolYesterday, Result.class).toFiguredOutObject(ProDataForCalProduction.class);

        a2dataStrYesterday = baseDataClient.getA2StatusDataForCalProduction(wellId, A2ProdDate);
        a2DataStatusYesterday = (ProDataForCalProduction) JSONObject.parseObject(a2dataStrYesterday, Result.class).toFiguredOutObject(ProDataForCalProduction.class);


        if (a2DataVolYesterday != null && a2DataStatusYesterday != null) {
            a2Basedata.LiqProdDaily = (a2DataVolYesterday.getLiqProdDaily() == null) ? 0 : a2DataVolYesterday.getLiqProdDaily();
            a2Basedata.hsl = (a2DataVolYesterday.getHsl() == null) ? 0 : a2DataVolYesterday.getHsl();
            a2Basedata.smd = (a2DataVolYesterday.getSmd() == null) ? 0 : a2DataVolYesterday.getSmd();
            a2Basedata.ymd = (a2DataVolYesterday.getYmd() == null) ? 0 : a2DataVolYesterday.getYmd();
            a2Basedata.qyb = (a2DataVolYesterday.getQyb() == null) ? 0 : a2DataVolYesterday.getQyb();
            a2Basedata.remarks = a2DataVolYesterday.getRemarks();
            a2Basedata.bj = (a2DataStatusYesterday.getBj() == null) ? 0 : a2DataStatusYesterday.getBj();
            a2Basedata.bs = (a2DataStatusYesterday.getBs() == null) ? 0 : a2DataStatusYesterday.getBs();
            a2Basedata.dym = (a2DataStatusYesterday.getDym() == null) ? 0 : a2DataStatusYesterday.getDym();
            a2Basedata.gas = (a2DataStatusYesterday.getGasProdDaily() == null) ? 0 : a2DataStatusYesterday.getGasProdDaily();
        }


        return a2Basedata;
    }

    //获取动态参数数据
    public DynamicParam getDynamicParam(String wellId, String dateStart, String dateEnd) {
        DynamicParam dynamicParam = new DynamicParam();
        double areaReal = 0.0;
        double sumYxccYesterday = 0.0;
        double sumBzxsYesterday = 0.0;
        double sumLoadDifference = 0.0;
        double sumArea = 0.0;
        double sumStroke = 0.0;
        double sumfrequence = 0.0;
        double AreaAvg = 0.0;
        double YxccYesterdayAvg = 0.0;
        double BdxsYesterdayAvg = 0.0;
        double LoadDifferenceAvg = 0.0;
        double strokeAvg = 0.0;
        double frequenceAvg = 0.0;
        List<AoidSinglegtYield> resultZdjg = aoidSinglegtYieldService.findByJhbasecs(wellId, dateStart, dateEnd);

        if (resultZdjg.size() > 0) {
            for (int y = 0; y < resultZdjg.size(); y++) {

                double sxzh = resultZdjg.get(y).getSxzh() == null ? 0 : resultZdjg.get(y).getSxzh();
                double xxzh = resultZdjg.get(y).getXxzh() == null ? 0 : resultZdjg.get(y).getXxzh();
                sumYxccYesterday += resultZdjg.get(y).getYxcc() == null ? 0 : resultZdjg.get(y).getYxcc();
                sumBzxsYesterday += resultZdjg.get(y).getBdxs() > 9 ? 1 : resultZdjg.get(y).getBdxs();
                List<List<Double>> sgtList = new ArrayList<>();
                if (Objects.nonNull(resultZdjg.get(y).getSgt())) {
                    sgtList = SGTUtil.encodeToUseList((String) resultZdjg.get(y).getSgt());
                    if (Objects.nonNull(sgtList) && sgtList.size() > 1) {
                        sgtList.remove(sgtList.size() - 1);
                        sgtList.add(sgtList.get(0));
                    }
                    Double[][] sgtValue = JSONObject.parseObject(sgtList.toString(), Double[][].class);
                    areaReal = CardAreaAlgorithm.calArea(sgtValue);
                    if (areaReal > 0) {
                        sumArea += areaReal;
                    }
                }
                sumLoadDifference += sxzh - xxzh;
                sumStroke += resultZdjg.get(y).getStroke() == null ? 0 : resultZdjg.get(y).getStroke();
                sumfrequence += resultZdjg.get(y).getFrequence() == null ? 0 : resultZdjg.get(y).getFrequence();
            }
            YxccYesterdayAvg = sumYxccYesterday / resultZdjg.size();
            BdxsYesterdayAvg = sumBzxsYesterday / resultZdjg.size();
            LoadDifferenceAvg = sumLoadDifference / resultZdjg.size();
            AreaAvg = sumArea / resultZdjg.size();
            strokeAvg = sumStroke / resultZdjg.size();
            frequenceAvg = sumfrequence / resultZdjg.size();
            dynamicParam.yxcc = YxccYesterdayAvg;
            dynamicParam.LoadDifference = LoadDifferenceAvg;
            dynamicParam.area = AreaAvg;
            dynamicParam.bdxs = BdxsYesterdayAvg;
            dynamicParam.stroke = strokeAvg;
            dynamicParam.frequence = frequenceAvg;
        }


        return dynamicParam;
    }


    //根据有效冲程变化，载荷差变化，面积变化推算产量
    public void ConjectureRcyl(double a2LiqProdDaily, double YxccYesterdayAvg, double yxccToday, double rcylToday,
                               double LoadDifferenceYesterdayAvg, double LMaxToday, double LMinToday,
                               double AreaYesterdayAvg, double areaToday, AoidMsg msg, double bdxs,
                               String wellId, Double[][] sgt, double stroke, double frequence, int sgtIsLegal, String eczdjg,
                               double bj, double bs, double hsl, double smd, double ymd, double qyb, double dym,
                               String isStop, String A2prodDateValue, double BdxsOriginal
    ) throws InstantiationException, IllegalAccessException, InvocationTargetException, NoSuchMethodException {

        double a2LiqProdDailyYesterday = 0.0;
        double yxccRate = 0.0;
        double loadDifferenceRate = 0.0;
        double areaRate = 0.0;
        double endA2Yield = 0.0;
        String endProdDateValue = null;
        double rcylRate = 0.0;


        //有效冲程稳定，载荷差上升，面积上升 -------缓慢结蜡，产量下降
        //有效冲程稳定，载荷差下降，面积下降 -------清蜡了，产量有所上升
        //间歇出油，供液不稳定，取标定值 7天内 与当前最接近的那个比对


        String num99Parm = "无配置";


        double rcyl = 0.0;
        double LoadDifferenceToday = LMaxToday - LMinToday;

        if (true) {
            LocalDate prodDate = msg.getBaseParam().getProdDate().toLocalDate();
            Result res = JSONObject.parseObject(baseDataClient.hotWashCheck7day(wellId, prodDate.format(DateTimeFormatter.ISO_LOCAL_DATE)), Result.class);
            long deltaDate = Long.parseLong(res.getData().toString());
            String paramExplain = "";
            if (deltaDate <= 7) {
                log.info("exec hot wash algorithm wellId {}",wellId);
                AoidDailyYield historyDailyYield = aoidDailyYieldService.getOne(new QueryWrapper<AoidDailyYield>()
                        .eq("well_id", wellId)
                        .ge("prod_date::date", prodDate.minusDays(deltaDate + 2))
                        .orderByAsc("prod_date")
                        .last("limit 1"));
                if (Objects.nonNull(historyDailyYield) && historyDailyYield.getProdDate().isBefore(prodDate.atTime(0, 0, 0))) {
                    List<AoidSinglegtYield> list = aoidSinglegtYieldService.list(new QueryWrapper<AoidSinglegtYield>()
                            .eq("well_id", wellId)
                            .eq("prod_date::date", historyDailyYield.getProdDate())
                    );
                    double predictRcylValue = calPredictHotWashRcyl(LoadDifferenceToday, historyDailyYield.getLiqProdDaily(), list);
                    BdxsOriginal = Coefficient(sgt, stroke, frequence, sgtIsLegal, eczdjg, bj, bs,
                            hsl, smd, ymd, qyb, dym, predictRcylValue);
                    if (deltaDate==7){
                        //will add 24 times, but no problem
                        WellAttr attr = new WellAttr();
                        attr.setWellId(wellId);
                        attr.setCoefficient(BdxsOriginal);
                        attr.setUpdateTime(prodDate.format(DateTimeFormatter.ISO_LOCAL_DATE)+" 00:00:00");
                        HashMap<Object, Object> processparamValue = new HashMap<>();
                        processparamValue.put("explain", "null");
                        processparamValue.put("date","null");
                        processparamValue.put("count", "null");
                        processparamValue.put("trend", "null");
                        attr.setMarkedParmExplain(JSONObject.toJSONString(processparamValue));
                        attr.setMarkedBy("热洗井筒算法生成");
                        baseDataClient.addCbPcDevWellAttr(attr);
                    }
                    paramExplain = num27Param;
                }
            }

            calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                    endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                    loadDifferenceRate, areaRate, "无", isStop, paramExplain, "0");
        } else {
            if (YxccYesterdayAvg > 0 && LoadDifferenceYesterdayAvg > 0 && AreaYesterdayAvg > 0) {
                endA2Yield = a2LiqProdDaily;
                endProdDateValue = A2prodDateValue;
                rcylRate = (rcylToday - a2LiqProdDaily) / a2LiqProdDaily;

                yxccRate = round2((yxccToday - YxccYesterdayAvg) / YxccYesterdayAvg);
                loadDifferenceRate = round2((LoadDifferenceToday - LoadDifferenceYesterdayAvg) / LoadDifferenceYesterdayAvg);
                areaRate = round2((areaToday - AreaYesterdayAvg) / AreaYesterdayAvg);


                //0、参数稳定
                if (Math.abs(yxccRate) <= 0.1 && Math.abs(loadDifferenceRate) <= 0.1 && Math.abs(areaRate) <= 0.1) {
                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num0Parm, "0");
                }
                //1、有效冲程上升/下降，载荷稳定，面积稳定------取有效冲程
                else if ((yxccRate >= 0.1 || yxccRate <= -0.1) && Math.abs(loadDifferenceRate) <= 0.1 && Math.abs(areaRate) <= 0.1) {
                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num1Parm, "1");

                }

                //2、有效冲程上升，载荷稳定，面积上升------取有效冲程
                else if (yxccRate >= 0.1 && Math.abs(loadDifferenceRate) <= 0.1 && areaRate >= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num2Parm, "1");
                }

                //3、有效冲程稳定，载荷稳定，面积上升/下降------取面积
                else if (Math.abs(yxccRate) <= 0.1 && Math.abs(loadDifferenceRate) <= 0.1 && (areaRate >= 0.1 || areaRate <= -0.1)) {
                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num3Parm, "1");
                }

                //4、有效冲程上升，载荷上升，面积上升------取有效冲程
                else if (yxccRate >= 0.1 && loadDifferenceRate >= 0.1 && areaRate >= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num4Parm, "1");
                }


                //5、有效冲程稳定，载荷上升，面积稳定------取面积/有效冲程---算作稳定
                else if (Math.abs(yxccRate) <= 0.1 && loadDifferenceRate >= 0.1 && Math.abs(areaRate) <= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num5Parm, "1");

                }


                //6、有效冲程下降，载荷稳定，面积下降--取有效冲程
                else if (yxccRate <= -0.1 && Math.abs(loadDifferenceRate) <= 0.1 && areaRate <= -0.1) {
                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num6Parm, "1");
                }

                //7、有效冲程上升，载荷下降，面积下降 --取面积
                else if (yxccRate >= 0.1 && loadDifferenceRate <= -0.1 && areaRate <= -0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num7Parm, "1");
                }

                //8、有效冲程稳定，载荷下降，面积下降--取面积
                else if (Math.abs(yxccRate) <= 0.1 && loadDifferenceRate <= -0.1 && areaRate <= -0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num8Parm, "1");
                }

                //9、有效冲程下降，载荷下降，面积下降--取有效冲程
                else if (yxccRate <= -0.1 && loadDifferenceRate <= -0.1 && areaRate <= -0.1) {
                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num9Parm, "1");
                }


                //10、有效冲程下降，载荷上升，面积上升--取面积
                else if (yxccRate <= -0.1 && loadDifferenceRate >= 0.1 && areaRate >= 0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num10Parm, "1");
                }

                //11、有效冲程下降，载荷上升，面积下降--取有效冲程
                else if (yxccRate <= -0.1 && loadDifferenceRate >= 0.1 && areaRate <= -0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num11Parm, "1");
                }

                //12、有效冲程下降，载荷稳定，面积上升--取面积
                else if (yxccRate <= -0.1 && Math.abs(loadDifferenceRate) <= 0.1 && areaRate >= 0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num12Parm, "1");
                }

                //13、有效冲程上升，载荷稳定，面积下降--取面积
                else if (yxccRate >= 0.1 && Math.abs(loadDifferenceRate) <= 0.1 && areaRate <= -0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num13Parm, "1");
                }


                //14、有效冲程上升,载荷上升,面积下降--取面积
                else if (yxccRate >= 0.1 && loadDifferenceRate >= 0.1 && areaRate <= -0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num14Parm, "1");
                }

                //15、有效冲程上升,载荷上升,面积稳定--取有效冲程
                else if (yxccRate >= 0.1 && loadDifferenceRate >= 0.1 && Math.abs(areaRate) <= 0.1) {
                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num15Parm, "1");

                }

                //16、有效冲程上升,载荷差下降,面积上升--取有效冲程
                else if (yxccRate >= 0.1 && loadDifferenceRate <= -0.1 && areaRate >= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num16Parm, "1");
                }

                //17、有效冲程上升,载荷差下降,面积稳定--取有效冲程
                else if (yxccRate >= 0.1 && loadDifferenceRate <= -0.1 && Math.abs(areaRate) <= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num17Parm, "1");
                }

                //18、有效冲程下降,载荷上升,面积稳定--取有效冲程
                else if (yxccRate <= -0.1 && loadDifferenceRate >= 0.1 && Math.abs(areaRate) <= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num18Parm, "1");
                }

                //19、有效冲程下降,载荷下降,面积上升--取面积
                else if (yxccRate <= -0.1 && loadDifferenceRate <= -0.1 && areaRate >= 0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num19Parm, "1");
                }

                //20、有效冲程下降,载荷下降,面积稳定--取有效冲程
                else if (yxccRate <= -0.1 && loadDifferenceRate <= -0.1 && Math.abs(areaRate) <= 0.1) {

                    paramCoefficientCalEnd(yxccToday, YxccYesterdayAvg, bdxs, rcylRate, yxccRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num20Parm, "1");
                }

                //21、有效冲程稳定,载荷上升,面积上升 ---取面积
                else if (Math.abs(yxccRate) <= 0.1 && loadDifferenceRate >= 0.1 && areaRate >= 0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num21Parm, "1");
                }

                //22、有效冲程稳定,载荷上升,面积下降--取面积
                else if (Math.abs(yxccRate) <= 0.1 && loadDifferenceRate >= 0.1 && areaRate <= -0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num22Parm, "1");
                }

                //23、有效冲程稳定,载荷下降,面积稳定--取有效冲程
                else if (Math.abs(yxccRate) <= 0.1 && loadDifferenceRate <= -0.1 && Math.abs(areaRate) <= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num23Parm, "1");
                }

                //24、有效冲程稳定-载荷差下降-面积上升-----取面积
                else if (Math.abs(yxccRate) <= 0.1 && loadDifferenceRate <= -0.1 && areaRate >= 0.1) {

                    paramCoefficientCalEnd(areaToday, AreaYesterdayAvg, bdxs, rcylRate, areaRate, rcylToday, wellId, msg, sgt, stroke, frequence, sgtIsLegal, eczdjg,
                            bj, bs, hsl, smd, ymd, qyb, dym, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate, loadDifferenceRate,
                            "无", isStop, num24Parm, "1");
                }
                //25、有效冲程下降-载荷差下降-面积稳定-----算作稳定
                else if (yxccRate <= -0.1 && loadDifferenceRate <= -0.1 && Math.abs(areaRate) <= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num25Parm, "1");

                }
                //26、有效冲程稳定-载荷差下降-面积稳定-----算作稳定
                else if (Math.abs(yxccRate) <= 0.1 && loadDifferenceRate <= -0.1 && Math.abs(areaRate) <= 0.1) {

                    calEnd(msg, BdxsOriginal, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                            endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, areaRate, "无", isStop, num26Parm, "1");

                } else {

                    String yxccDescribe = null;
                    String loadDifferenceDescribe = null;
                    String areaDescribe = null;

                    if (yxccRate >= 0.1) {
                        yxccDescribe = "有效冲程上升-";
                    } else if (yxccRate <= -0.1) {
                        yxccDescribe = "有效冲程下降-";
                    } else if (Math.abs(yxccRate) <= 0.1) {
                        yxccDescribe = "有效冲程稳定-";
                    }

                    if (loadDifferenceRate >= 0.1) {
                        loadDifferenceDescribe = "载荷差上升-";
                    } else if (loadDifferenceRate <= -0.1) {
                        loadDifferenceDescribe = "载荷差下降-";
                    } else if (Math.abs(loadDifferenceRate) <= 0.1) {
                        loadDifferenceDescribe = "载荷差稳定-";
                    }

                    if (areaRate >= 0.1) {
                        areaDescribe = "面积上升-";
                    } else if (areaRate <= -0.1) {
                        areaDescribe = "面积下降-";
                    } else if (Math.abs(areaRate) <= 0.1) {
                        areaDescribe = "面积稳定-";
                    }

                    String paramSummary = "(" + yxccDescribe + "" + loadDifferenceDescribe + "" + areaDescribe + ")";


                    if (Math.abs(rcylRate) < 0.1 && bdxs < 9) {
                        calEnd(msg, bdxs, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                                endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                                loadDifferenceRate, areaRate, "无", isStop, num99Parm + paramSummary, "2");
                    } else {
                        rcyl = endA2Yield;
                        realAoidCl(msg, sgt, stroke, frequence, sgtIsLegal, eczdjg, bj
                                , bs, hsl, smd, ymd, qyb, dym, rcyl, areaRate, LoadDifferenceToday, areaToday, endProdDateValue, BdxsOriginal,
                                endA2Yield, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                                loadDifferenceRate, "无", isStop, num99Parm + paramSummary, "2", true, bdxs);
                    }


                }

            } else {
                calEnd(msg, 1.0, 0, 0, null, 0,
                        0, 0, 0, 0, 0,
                        0, 0, null, null, "无匹配标定信息", null);
            }
        }
    }

    double calPredictHotWashRcyl(double loadDifference, double historyRcly, List<AoidSinglegtYield> historySinglegtYield) {
        Double[] loadDifferences = historySinglegtYield.stream()
                .map(AoidSinglegtYield::getLoadDifference)
                .collect(Collectors.toList())
                .toArray(new Double[]{});
        //json parse will filter null element
        double aveHisLoadDiff = Arrays.stream(JSONObject.parseObject(JSONObject.toJSONString(loadDifferences),double[].class)).average().getAsDouble();
        // limit not great than 0.8 and not less than 0.2

        double compare = Math.min(loadDifference/aveHisLoadDiff,0.8);
        if (compare<0.2)compare = -0.4;
        return historyRcly*(0.4+compare);
    }

    //实时产量推测并进行标定
    public void realAoidCl(AoidMsg msg, Double[][] sgt, double stroke, double frequence, int sgtIsLegal, String eczdjg,
                           double bj, double bs, double hsl, double smd, double ymd, double qyb, double dym, double ConjectureRcylValue, double areaRate,
                           double LoadDifferenceToday, double areaToday, String A2prodDate, double Bdxs,
                           double a2LiqProdDailyYesterday, double YxccYesterdayAvg, double LoadDifferenceYesterdayAvg, double AreaYesterdayAvg, double yxccRate,
                           double loadDifferenceRate, String measures, String isStop, String parmExplain, String parmFlag, boolean coefficientFlag, double bdxsEnd)
            throws InvocationTargetException, InstantiationException, IllegalAccessException, NoSuchMethodException {
        if (coefficientFlag == true) {
            pzxsRealCl(msg, sgt, stroke, frequence, sgtIsLegal, eczdjg, bj
                    , bs, hsl, smd, ymd, qyb, dym, ConjectureRcylValue, LoadDifferenceToday, areaToday, A2prodDate, Bdxs,
                    a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                    loadDifferenceRate, areaRate, measures, isStop, parmExplain, parmFlag);
        } else {
            calEnd(msg, bdxsEnd, LoadDifferenceToday, areaToday, A2prodDate, Bdxs,
                    a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                    loadDifferenceRate, areaRate, measures, isStop, parmExplain, parmFlag);
        }


    }


    //根据参数变化推算最终液量
    public void paramCoefficientCalEnd(double paramToday, double paramYesterday, double bdxsEnd, double rcylRate, double paramRate, double rcylToday, String wellId, AoidMsg msg, Double[][] sgt, double stroke, double frequence, int sgtIsLegal, String eczdjg,
                                       double bj, double bs, double hsl, double smd, double ymd, double qyb, double dym, double areaRate,
                                       double LoadDifferenceToday, double areaToday, String A2prodDateMeasures, double BdxsMeasure,
                                       double a2LiqProdDailyYesterday, double YxccYesterdayAvg, double LoadDifferenceYesterdayAvg, double AreaYesterdayAvg, double yxccRate,
                                       double loadDifferenceRate, String measures, String isStop, String parmExplain, String parmFlag)
            throws InvocationTargetException, InstantiationException, IllegalAccessException, NoSuchMethodException {
        double rcyl = 0.0;
        double rcylproportion = 0.0;

        double rcylRateValue = Math.abs(rcylRate);
        double paramRateValue = Math.abs(paramRate);
        double paramRateValueRate = Math.abs(areaToday / AreaYesterdayAvg);
        double paramRateValueRateEnd = 0.0;
        double parameter = Math.abs((rcylRateValue - paramRateValue) / paramRateValue);


        if (paramToday > paramYesterday) {
            if (parmExplain.equals("有效冲程稳定,载荷上升,面积上升---取面积")) {
                if (msg.getDiagnoseResult().getResult2().equals("油稠")) {
                    double yiedOilConsistency = a2LiqProdDailyYesterday * 0.3;
                    double yieldValuation = 5;
                    double yieldOilEnd = 0.0;
                    if (yiedOilConsistency >= yieldValuation) {
                        yieldOilEnd = yiedOilConsistency;
                    } else {
                        yieldOilEnd = yieldValuation;
                    }
                    rcyl = a2LiqProdDailyYesterday + Math.abs(yieldOilEnd * paramRateValue);
                } else {
                    if (paramRateValueRate > 2) {
                        paramRateValueRateEnd = 2;
                    } else if (paramRateValueRate < 1.1) {
                        paramRateValueRateEnd = 1.1;
                    } else {
                        paramRateValueRateEnd = paramRateValueRate;
                    }
                    //缓慢结蜡，产量下降
                    rcylproportion =
                            -17.767 * (Math.pow(paramRateValueRateEnd, 5))
                                    + 136.68 * (Math.pow(paramRateValueRateEnd, 4))
                                    - 413.14 * (Math.pow(paramRateValueRateEnd, 3))
                                    + 613.41 * (Math.pow(paramRateValueRateEnd, 2))
                                    - 448.74 * paramRateValueRateEnd
                                    + 130.76;
                    rcyl = round2(a2LiqProdDailyYesterday * rcylproportion);
                }

                realAoidCl(msg, sgt, stroke, frequence, sgtIsLegal, eczdjg, bj
                        , bs, hsl, smd, ymd, qyb, dym, rcyl, areaRate, LoadDifferenceToday, areaToday, A2prodDateMeasures, BdxsMeasure,
                        a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                        loadDifferenceRate, measures, isStop, parmExplain, parmFlag, true, bdxsEnd);
            } else {
                if (parameter < 0.1 && bdxsEnd < 9) {
                    realAoidCl(msg, sgt, stroke, frequence, sgtIsLegal, eczdjg, bj
                            , bs, hsl, smd, ymd, qyb, dym, rcyl, areaRate, LoadDifferenceToday, areaToday, A2prodDateMeasures, BdxsMeasure,
                            a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, measures, isStop, parmExplain, parmFlag, false, bdxsEnd);
                } else {
                    rcyl = (a2LiqProdDailyYesterday + Math.abs(a2LiqProdDailyYesterday * paramRateValue)) * 0.85;
                    realAoidCl(msg, sgt, stroke, frequence, sgtIsLegal, eczdjg, bj
                            , bs, hsl, smd, ymd, qyb, dym, rcyl, areaRate, LoadDifferenceToday, areaToday, A2prodDateMeasures, BdxsMeasure,
                            a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, measures, isStop, parmExplain, parmFlag, true, bdxsEnd);

                }
            }


        } else if (paramToday < paramYesterday) {
            if (parmExplain.equals("有效冲程稳定，载荷下降，面积下降------取面积")) {
                if (paramRateValueRate > 1) {
                    paramRateValueRateEnd = 1;
                } else if (paramRateValueRate < 0) {
                    paramRateValueRateEnd = 0;
                } else {
                    paramRateValueRateEnd = paramRateValueRate;
                }
                //清蜡了，产量有所上升
                rcylproportion =
                        3.3457 * (Math.pow(paramRateValueRateEnd, 6))
                                - 20.924 * (Math.pow(paramRateValueRateEnd, 5))
                                + 50.168 * (Math.pow(paramRateValueRateEnd, 4))
                                - 56.534 * (Math.pow(paramRateValueRateEnd, 3))
                                + 27.627 * (Math.pow(paramRateValueRateEnd, 2))
                                - 2.6753 * paramRateValueRateEnd
                                + 0.0027;

                rcyl = round2(a2LiqProdDailyYesterday * rcylproportion);
                realAoidCl(msg, sgt, stroke, frequence, sgtIsLegal, eczdjg, bj
                        , bs, hsl, smd, ymd, qyb, dym, rcyl, areaRate, LoadDifferenceToday, areaToday, A2prodDateMeasures, BdxsMeasure,
                        a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                        loadDifferenceRate, measures, isStop, parmExplain, parmFlag, true, bdxsEnd);
            } else {
                if (parameter < 0.1 && bdxsEnd < 9) {
                    realAoidCl(msg, sgt, stroke, frequence, sgtIsLegal, eczdjg, bj
                            , bs, hsl, smd, ymd, qyb, dym, rcyl, areaRate, LoadDifferenceToday, areaToday, A2prodDateMeasures, BdxsMeasure,
                            a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, measures, isStop, parmExplain, parmFlag, false, bdxsEnd);
                } else {
                    rcyl = (a2LiqProdDailyYesterday - Math.abs(a2LiqProdDailyYesterday * paramRateValue)) * 0.85;
                    realAoidCl(msg, sgt, stroke, frequence, sgtIsLegal, eczdjg, bj
                            , bs, hsl, smd, ymd, qyb, dym, rcyl, areaRate, LoadDifferenceToday, areaToday, A2prodDateMeasures, BdxsMeasure,
                            a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                            loadDifferenceRate, measures, isStop, parmExplain, parmFlag, true, bdxsEnd);
                }
            }


        }
    }


    //针对放气措施查询历史液量
    public JSONObject getVolDailyProdDate(String wellId, String identification, String prodDate) {
        String newProdDate = baseDataClient.getCbPcProWellboreVolDailyProdDate(wellId, identification, prodDate);
        Result ProdDateResult = JSONObject.parseObject(newProdDate, Result.class);
        Object dataProd = ProdDateResult.getData();
        JSONObject jsonArrayProd = JSONObject.parseObject(dataProd.toString());
        return jsonArrayProd;
    }


    //保留2位有效数字
    public static double round2(double in) {
        DecimalFormat df = new DecimalFormat("######0.00");
        return Double.valueOf(df.format(in));
    }


    //实时系数计算--参照有效冲程，载荷差，面积进行计算
    public void pzxsRealCl(AoidMsg msg, Double[][] sgt, double stroke, double frequence, int sgtIsLegal, String eczdjg,
                           double bj, double bs, double hsl, double smd, double ymd, double qyb, double dym, double ConjectureRcylValue, double LoadDifferenceToday, double areaToday, String A2prodDateMeasures, double BdxsMeasure,
                           double a2LiqProdDailyYesterday, double YxccYesterdayAvg, double LoadDifferenceYesterdayAvg, double AreaYesterdayAvg, double yxccRate,
                           double loadDifferenceRate, double areaRate, String measures, String isStop, String parmExplain, String parmFlag
    )
            throws InvocationTargetException, InstantiationException, IllegalAccessException, NoSuchMethodException {
        double pzxsQr = 0.0;
        pzxsQr = Coefficient(sgt, stroke, frequence, sgtIsLegal, eczdjg, bj, bs,
                hsl, smd, ymd, qyb, dym, ConjectureRcylValue);
        calEnd(msg, pzxsQr, LoadDifferenceToday, areaToday, A2prodDateMeasures, BdxsMeasure,
                a2LiqProdDailyYesterday, YxccYesterdayAvg, LoadDifferenceYesterdayAvg, AreaYesterdayAvg, yxccRate,
                loadDifferenceRate, areaRate, measures, isStop, parmExplain, parmFlag);
    }


    //稀油实时系数计算之二分法
    public double Coefficient(Double[][] sgt, double stroke, double frequence, int sgtIsLegal, String eczdjg, double
            bj, double bs, double hsl, double smd, double ymd, double qyb, double dym, double ConjectureRcylValue) {
        double u = 0.0;
        double d = 10;
        double pre_pzxs = 0.0;
        while (d - u > 1e-6) {
            double xs = (u + d) / 2;

            AoidSinglegtYieldReal rcylT = calreal(sgt, stroke,
                    frequence, sgtIsLegal, eczdjg, bj, bs,
                    hsl, smd, ymd, qyb, dym, xs);


            if (rcylT.rcl - ConjectureRcylValue > ConjectureRcylValue * 0.01) d = xs;
            else if (ConjectureRcylValue - rcylT.rcl > ConjectureRcylValue * 0.01) {
                u = xs;
            } else {
                if (Math.abs((u + d) / 2) < 0.1 || Math.abs((u + d) / 2) > 10 || Math.abs(pre_pzxs - (u + d) / 2) <= 0.01) {
                    break;
                }
                if (ConjectureRcylValue - rcylT.rcl > ConjectureRcylValue * 0.01) {
                    u = xs;
                } else if (rcylT.rcl - ConjectureRcylValue > ConjectureRcylValue * 0.01) {
                    d = xs;
                }
            }
            pre_pzxs = (u + d) / 2;
        }
        double xs2 = (u + d) / 2;

        return xs2;
    }

    //稀油实时量液
    public AoidSinglegtYieldReal calreal(Double[][] sgt, double stroke, double frequence, int sgtIsLegal, String eczdjg, double
            bj, double bs, double hsl, double smd, double ymd, double qyb, double dym, double pzxs) {


        AoidSinglegtYieldReal realYield = new AoidSinglegtYieldReal();
        AoidSinglewellConfig effectStrockModel = aoidSinglewellConfigService.getConfigOneObjByID(1);
        Double[][] bgt = null;


        bgt = calPumpCard.cal_bgt(sgt, stroke, sgtIsLegal, 1.0, eczdjg);


        if (bgt != null) {
            CalDiagramProduction.CalProductionResult production = new CalDiagramProduction.CalProductionResult();
            production = calDiagramProduction.calProduction(
                    sgt, bgt, stroke, frequence, eczdjg, bj, bs, hsl, smd, ymd, qyb, dym, pzxs, effectStrockModel
            );
            realYield.rcl = production.rcyl1;
            realYield.yxcc = production.yxcc;
        }
        return realYield;
        //endregion
    }

    //实时计算量液类
    public class AoidSinglegtYieldReal {
        private Double yxcc;
        private Double rcl;
    }

    //A2基础数据类
    public class A2Basedata {
        private Double LiqProdDaily;
        private Double bj;
        private Double bs;
        private Double hsl;
        private Double smd;
        private Double ymd;
        private Double qyb;
        private Double dym;
        private Double gas;
        private String remarks;
    }

    //动态参数类
    public class DynamicParam {
        private Double yxcc;
        private Double LoadDifference;
        private Double area;
        private Double bdxs;
        private Double stroke;
        private Double frequence;
    }


    //稀油量液检测
    private boolean checkInputDataBeforeCalDiagramProduction(CalDiagramProduction.CalProductionResult production, ProDataForCalProduction a2data, ProDataForCalProduction a2dataVol, Double[][] bgt, AoidMsg.BaseParam dcbp, AoidMsg.DiagnoseResult diagnoseResult, AoidGkModel model, AoidSinglewellConfig effectStrockModel, double areaReal) {
        production.remark = "";
        if (bgt == null || bgt.length == 0) production.appendRemark("泵功图无法计算");

        if (areaReal <= 0 || areaReal > 500) production.appendRemark("功图反转");

        if (Objects.isNull(dcbp)) production.appendRemark("缺失功图参数");
        else {
            if (dcbp.getIslegal() != 1) {
                if (Objects.nonNull(diagnoseResult) && Objects.nonNull(diagnoseResult.getResult2()) && !diagnoseResult.getResult2().isEmpty())
                    production.appendRemark("功图不合法:" + diagnoseResult.getResult2());
                else production.appendRemark("功图不合法");
            }

            if (Objects.isNull(dcbp.getN())) production.appendRemark("缺失冲次");
            else if (dcbp.getN() == 0) production.appendRemark("冲次为0");


            if (Objects.isNull(dcbp.getS())) production.appendRemark("缺失冲程");
            else if (dcbp.getS() == 0) production.appendRemark("冲程为0");

        }

        if (Objects.isNull(a2data)) production.appendRemark("缺失井状态日数据");
        else {
            if (Objects.isNull(a2data.getBj())) production.appendRemark("缺失泵径");
            if (Objects.isNull(a2data.getBs())) production.appendRemark("缺失泵深");
            if (Objects.isNull(a2data.getDym())) production.appendRemark("缺失动液面");
        }


        if (Objects.isNull(a2dataVol)) production.appendRemark("缺失井产量日数据");
        else {
            if (Objects.isNull(a2dataVol.getHsl())) production.appendRemark("缺失含水率");
            if (Objects.isNull(a2dataVol.getSmd())) production.appendRemark("缺失水比重");
            if (Objects.isNull(a2dataVol.getQyb())) production.appendRemark("缺失气油比");
            if (Objects.isNull(a2dataVol.getYmd())) production.appendRemark("缺失油比重");
        }


        if (Objects.isNull(model) || Objects.isNull(model.getGkxs()))
            production.appendRemark("缺失工况对应计量模型");

        if (Objects.isNull(effectStrockModel)) production.appendRemark("缺失有效冲程计算模型");

        if (Objects.isNull(diagnoseResult) || Objects.isNull(diagnoseResult.getResult1())
                || Objects.isNull(diagnoseResult.getResult2()) || diagnoseResult.getResult1().isEmpty()
                || diagnoseResult.getResult2().isEmpty()) production.appendRemark("缺失诊断结果数据");

        if (!production.remark.isEmpty())
            return false;
        return true;
    }

    //稀油量液算法
    public void calEnd(AoidMsg msg, double finalCoefficient, double LoadDifferenceToday, double areaToday, String A2prodDate, double Bdxs,
                       double a2LiqProdDailyYesterday, double YxccYesterdayAvg, double LoadDifferenceYesterdayAvg, double AreaYesterdayAvg, double yxccRate,
                       double loadDifferenceRate, double areaRate, String measures, String isStop, String parmExplain, String parmFlag) throws InstantiationException, IllegalAccessException, InvocationTargetException, NoSuchMethodException {


        String A2prodDateNull = "1998-01-01 00:00:00";
        ProDataForCalProduction a2DataStatus = null;
        ProDataForCalProduction a2DataVol = null;
        ProDataForCalProduction wellAttrdata = null;
        ProDataForCalProduction wellMeterteam = null;
        double Tlvd = 0;
//        double finalCoefficientEnd =0.0;
//        Double finalCoefficientEndValue =null;
//        Double finalCoefficientEndValueTrue =null;
        AoidSinglegtYield aoidSinglegtYield = new AoidSinglegtYield();

        //region step 1:
        AoidMsg.BaseParam baseParam = msg.getBaseParam();
        if (Objects.nonNull(baseParam) && Objects.nonNull(baseParam.getProdDate()) &&
                Objects.nonNull(baseParam.getWellId())) {
            aoidSinglegtYield.setWellId(baseParam.getWellId());
            aoidSinglegtYield.setWellCommonName(baseParam.getWellname());
            aoidSinglegtYield.setProdDate(baseParam.getProdDate());
            aoidSinglegtYield.setStroke(baseParam.getS());
            aoidSinglegtYield.setFrequence(baseParam.getN());
            aoidSinglegtYield.setSxzh(baseParam.getLMax());
            aoidSinglegtYield.setXxzh(baseParam.getLMin());
            aoidSinglegtYield.setSgt(baseParam.getSgt());
            aoidSinglegtYield.setSgtIsLegal(baseParam.getIslegal());
            String a2Date = baseParam.getProdDate().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
            String a2dataStr = baseDataClient.getA2StatusDataForCalProduction(baseParam.getWellId(), a2Date);
            a2DataStatus = (ProDataForCalProduction) JSONObject.parseObject(a2dataStr, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
            String a2dataStrVol = baseDataClient.getA2VolDataForCalProduction(baseParam.getWellId(), a2Date);
            a2DataVol = (ProDataForCalProduction) JSONObject.parseObject(a2dataStrVol, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
            String WellAttr = baseDataClient.selectOneByWellId(baseParam.getWellId());
            wellAttrdata = (ProDataForCalProduction) JSONObject.parseObject(WellAttr, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
            if (wellAttrdata == null) wellAttrdata = new ProDataForCalProduction().setPzxs(1d);
            else if (wellAttrdata.getPzxs() == 0) wellAttrdata.setPzxs(1d);
            String wellStrMeterteamdate = baseParam.getProdDate().minusDays(1).format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
            String wellStrMeterteam = baseDataClient.getWellMeterTeamForCalProduction(baseParam.getWellId(), wellStrMeterteamdate);
            wellMeterteam = (ProDataForCalProduction) JSONObject.parseObject(wellStrMeterteam, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
        }
        //endregion
        //region step 2:
        AoidMsg.DiagnoseResult diagnoseResult = msg.getDiagnoseResult();
        AoidGkModel model = null;
        if (Objects.nonNull(diagnoseResult)) {

            aoidSinglegtYield.setEczdjg(diagnoseResult.getResult2());
            aoidSinglegtYield.setZdjg(diagnoseResult.getResult1());

            Integer result1 = Integer.parseInt(diagnoseResult.getResult1());
            if (result1 >= 1) {
                aoidSinglegtYield.setSgtIsLegal(1);
            } else {
                aoidSinglegtYield.setSgtIsLegal(0);
            }
            model = aoidGkModelService.getGKModelByResultType(diagnoseResult.getResult2());
        }
        AoidSinglewellConfig effectStrockModel = aoidSinglewellConfigService.getConfigOneObjByID(1);


        Double[][] bgt = null;
        Double[][] sgt = baseParam.getSgt() == null ? null : SGTUtil.encodeToDoubleArray(baseParam.getSgt());
        double areaReal = CardAreaAlgorithm.calArea(sgt);
        if (Objects.nonNull(baseParam) && Objects.nonNull(diagnoseResult)) {
            bgt = calPumpCard.cal_bgt(
                    sgt,
                    baseParam.getS(),
                    baseParam.getIslegal(),
                    1.0,
                    diagnoseResult.getResult2());
        }


        CalDiagramProduction.CalProductionResult production = new CalDiagramProduction.CalProductionResult();

        if (Objects.isNull(parmExplain) || !parmExplain.equals(num27Param)){
            if (finalCoefficient > 9) finalCoefficient = 1;
            if (model != null && !model.getTriggerFlag().equals("0")) {
                finalCoefficient = finalCoefficient * model.getGkxs();
                finalCoefficient = finalCoefficient < 0.1 ? 0.015 : finalCoefficient;
            }
        }



        boolean checked = checkInputDataBeforeCalDiagramProduction(production, a2DataStatus, a2DataVol, bgt, baseParam, diagnoseResult, model, effectStrockModel, areaReal);
        aoidSinglegtYield.setCalIsNormal(checked ? 1 : 0);
        if (checked) {
            production = calDiagramProduction.calProduction(
                    sgt,
                    bgt,
                    baseParam.getS(),
                    baseParam.getN(),
                    diagnoseResult.getResult2(),
                    a2DataStatus.getBj(),
                    a2DataStatus.getBs(),
                    a2DataVol.getHsl(),
                    a2DataVol.getSmd(),
                    a2DataVol.getYmd(),
                    a2DataVol.getQyb(),
                    a2DataStatus.getDym(),
                    finalCoefficient,
                    effectStrockModel
            );
        }

        //endregion

        //region step 3:
        if (a2DataStatus != null) {
            aoidSinglegtYield.setBj(a2DataStatus.getBj());
            aoidSinglegtYield.setBs(a2DataStatus.getBs());
            if (Objects.nonNull(a2DataStatus.getBs()) && Objects.nonNull(a2DataStatus.getDym()))
                aoidSinglegtYield.setCmd(Math.round((a2DataStatus.getBs().doubleValue() - a2DataStatus.getDym().doubleValue()) * 10) / 10d);
            aoidSinglegtYield.setYzzj(a2DataStatus.getBj());
            aoidSinglegtYield.setHy(a2DataStatus.getBackPres());
            aoidSinglegtYield.setYy(a2DataStatus.getTubingPres());
            aoidSinglegtYield.setTy(a2DataStatus.getCasingPres());
            aoidSinglegtYield.setA2Dym(a2DataStatus.getDym());
        }
        if (a2DataVol != null) {
            aoidSinglegtYield.setHsl(a2DataVol.getHsl());
            aoidSinglegtYield.setSmd(a2DataVol.getSmd());
            aoidSinglegtYield.setYmd(a2DataVol.getYmd());
            aoidSinglegtYield.setQyb(a2DataVol.getQyb());
            aoidSinglegtYield.setA2LiqProdDaily(a2DataVol.getLiqProdDaily());
            aoidSinglegtYield.setA2OilProdDaily(a2DataVol.getOilProdDaily());
            aoidSinglegtYield.setA2WaterProdDaily(a2DataVol.getWaterProdDaily());
            aoidSinglegtYield.setA2GasProdDaily(a2DataVol.getGasProdDaily());
            aoidSinglegtYield.setA2WaterCut(a2DataVol.getHsl());
            aoidSinglegtYield.setA2Remark(a2DataVol.getRemarks());
            aoidSinglegtYield.setA2ProdTime(a2DataVol.getProdTime());
        }


        if (wellMeterteam != null) {
            aoidSinglegtYield.setTestLiquVolDaily(wellMeterteam.getTlvd());
        } else {
            aoidSinglegtYield.setTestLiquVolDaily(Tlvd);
        }

        if (bgt != null && bgt.length > 0) {
            aoidSinglegtYield.setBgt(SGTUtil.encodeToString(bgt));
        }
        if (production != null) {
            aoidSinglegtYield.setRemark(production.remark);

            aoidSinglegtYield.setOilProdDaily(production.rcyl);
            String now = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
            DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
            aoidSinglegtYield.setCreateTime(LocalDateTime.parse(now, df));//创建时间
            aoidSinglegtYield.setLiqProdDaily(production.rcyl1);
            aoidSinglegtYield.setGasProdDaily(production.rcql);
            aoidSinglegtYield.setBx(production.bx);
            //aoidSinglegtYield.setFlag();
            //aoidSinglegtYield.setBdxs();
            aoidSinglegtYield.setDym(production.dym);//新增动液面计算
            aoidSinglegtYield.setLlpl(production.llpl);
            aoidSinglegtYield.setZcc(production.zcc);
            aoidSinglegtYield.setSjcc(production.sjcc);
            aoidSinglegtYield.setYxcc(production.yxcc);
            aoidSinglegtYield.setCcss(production.ccss);
            aoidSinglegtYield.setLsss(production.lsss);
            aoidSinglegtYield.setGyss(production.gyss);
            aoidSinglegtYield.setWaterProdDaily(production.rcsl);
            aoidSinglegtYield.setBdxs(finalCoefficient);//标定系数
            aoidSinglegtYield.setStrokeRatio(production.l_StrokeRatio);
        }
        aoidSinglegtYield.setScsj(24d);

        aoidSinglegtYield.setLoadDifference(LoadDifferenceToday);
        aoidSinglegtYield.setArea(String.valueOf(areaToday).length() > 7 ?
                String.valueOf(areaToday).substring(0, 5) : String.valueOf(areaToday));
        if (A2prodDate != null) {
            aoidSinglegtYield.setComparisonProdDate(LocalDateTime.parse(A2prodDate, df));
        } else {
            aoidSinglegtYield.setComparisonProdDate(LocalDateTime.parse(A2prodDateNull, df));
        }

        aoidSinglegtYield.setComparisonCoefficient(Bdxs);

        aoidSinglegtYield.setComparisonYield(a2LiqProdDailyYesterday);

        aoidSinglegtYield.setComparisonYxcc(String.valueOf(YxccYesterdayAvg).length() > 7 ?
                String.valueOf(YxccYesterdayAvg).substring(0, 5) : String.valueOf(YxccYesterdayAvg));


        aoidSinglegtYield.setComparisonLoadDifference(String.valueOf(LoadDifferenceYesterdayAvg).length() > 7 ?
                String.valueOf(LoadDifferenceYesterdayAvg).substring(0, 5) : String.valueOf(LoadDifferenceYesterdayAvg));


        aoidSinglegtYield.setComparisonArea(String.valueOf(AreaYesterdayAvg).length() > 7 ?
                String.valueOf(AreaYesterdayAvg).substring(0, 5) : String.valueOf(AreaYesterdayAvg));

        aoidSinglegtYield.setYxccRate(String.valueOf(yxccRate).length() > 7 ?
                String.valueOf(yxccRate).substring(0, 5) : String.valueOf(yxccRate));

        aoidSinglegtYield.setLoadDifferenceRate(String.valueOf(loadDifferenceRate).length() > 7 ?
                String.valueOf(loadDifferenceRate).substring(0, 5) : String.valueOf(loadDifferenceRate));

        aoidSinglegtYield.setAreaRate(String.valueOf(areaRate).length() > 7 ?
                String.valueOf(areaRate).substring(0, 5) : String.valueOf(areaRate));

        aoidSinglegtYield.setMeasureFlag(measures);
        aoidSinglegtYield.setIsStopWell(isStop);
        aoidSinglegtYield.setParmExplain(parmExplain);
        aoidSinglegtYield.setParmFlag(parmFlag);


        if (!aoidSinglegtYieldService.update(aoidSinglegtYield, new LambdaUpdateWrapper<AoidSinglegtYield>()
                .eq(AoidSinglegtYield::getWellId, aoidSinglegtYield.getWellId())
                .eq(AoidSinglegtYield::getProdDate, aoidSinglegtYield.getProdDate())))
            aoidSinglegtYieldService.save(aoidSinglegtYield);

        //endregion
    }


    //稀油量液检测
    private boolean checkInputDataBeforeCalDiagramProductionEnd(CalDiagramProduction.CalProductionResult production, ProDataForCalProductionValue a2data, ProDataForCalProductionValue a2dataVol, Double[][] bgt, AoidMsgValue.BaseParam dcbp, AoidMsgValue.DiagnoseResult diagnoseResult, AoidGkModel model, AoidSinglewellConfig effectStrockModel, double areaReal) {
        production.remark = "";
        if (bgt == null || bgt.length == 0) production.appendRemark("泵功图无法计算");

        if (areaReal <= 0 || areaReal > 500) production.appendRemark("功图错误");

        if (Objects.isNull(dcbp)) production.appendRemark("缺失功图参数");
        else {
            if (dcbp.getIslegal() != 1) {
                if (Objects.nonNull(diagnoseResult) && Objects.nonNull(diagnoseResult.getResult2()) && !diagnoseResult.getResult2().isEmpty())
                    production.appendRemark("功图不合法:" + diagnoseResult.getResult2());
                else production.appendRemark("功图不合法");
            }

            if (Objects.isNull(dcbp.getN())) production.appendRemark("缺失冲次");
            else if (dcbp.getN() == 0) production.appendRemark("冲次为0");


            if (Objects.isNull(dcbp.getS())) production.appendRemark("缺失冲程");
            else if (dcbp.getS() == 0) production.appendRemark("冲程为0");

        }

        if (Objects.isNull(a2data)) production.appendRemark("缺失井状态日数据");
        else {
            if (Objects.isNull(a2data.bj)) production.appendRemark("缺失泵径");
            if (Objects.isNull(a2data.bs)) production.appendRemark("缺失泵深");
            if (Objects.isNull(a2data.dym)) production.appendRemark("缺失动液面");
        }


        if (Objects.isNull(a2dataVol)) production.appendRemark("缺失井产量日数据");
        else {
            if (Objects.isNull(a2dataVol.hsl)) production.appendRemark("缺失含水率");
            if (Objects.isNull(a2dataVol.smd)) production.appendRemark("缺失水比重");
            if (Objects.isNull(a2dataVol.qyb)) production.appendRemark("缺失气油比");
            if (Objects.isNull(a2dataVol.ymd)) production.appendRemark("缺失油比重");
        }


        if (Objects.isNull(model) || Objects.isNull(model.getGkxs()))
            production.appendRemark("缺失工况对应计量模型");

        if (Objects.isNull(effectStrockModel)) production.appendRemark("缺失有效冲程计算模型");

        if (Objects.isNull(diagnoseResult) || Objects.isNull(diagnoseResult.getResult1())
                || Objects.isNull(diagnoseResult.getResult2()) || diagnoseResult.getResult1().isEmpty()
                || diagnoseResult.getResult2().isEmpty()) production.appendRemark("缺失诊断结果数据");

        if (!production.remark.isEmpty())
            return false;
        return true;
    }


    //稀油量液算法
    public double calEndLiq(AoidMsgValue msg, double finalCoefficient, double LoadDifferenceToday, double areaToday, String A2prodDate, double Bdxs,
                            double a2LiqProdDailyYesterday, double YxccYesterdayAvg, double LoadDifferenceYesterdayAvg, double AreaYesterdayAvg, double yxccRate,
                            double loadDifferenceRate, double areaRate, String measures, String isStop, String parmExplain, String parmFlag) throws InstantiationException, IllegalAccessException, InvocationTargetException, NoSuchMethodException {


        double LiqProdDaily = 0.0;

        ProDataForCalProductionValue a2DataStatus = new ProDataForCalProductionValue();
        ProDataForCalProductionValue a2DataVol = new ProDataForCalProductionValue();
        Double finalCoefficientEnd = 0.0;
        Double finalCoefficientEndValue = null;
        AoidSinglegtYield aoidSinglegtYield = new AoidSinglegtYield();

        //region step 1:
        AoidMsgValue.BaseParam baseParam = msg.getBaseParam();
        long st = System.currentTimeMillis();
        if (Objects.nonNull(baseParam) && Objects.nonNull(baseParam.getProdDate()) &&
                Objects.nonNull(baseParam.getWellId())) {
            aoidSinglegtYield.setWellId(baseParam.getWellId());
            aoidSinglegtYield.setWellCommonName(baseParam.getWellname());
            aoidSinglegtYield.setProdDate(baseParam.getProdDate());
            aoidSinglegtYield.setStroke(baseParam.getS());
            aoidSinglegtYield.setFrequence(baseParam.getN());
            if (msg.getDiagnoseResult().getResult1().equals("-1")) {
                aoidSinglegtYield.setSxzh(0.0);
                aoidSinglegtYield.setXxzh(0.0);
            } else {
                aoidSinglegtYield.setSxzh(baseParam.getLMax());
                aoidSinglegtYield.setXxzh(baseParam.getLMin());
            }

            aoidSinglegtYield.setSgt(baseParam.getSgt());
            aoidSinglegtYield.setSgtIsLegal(baseParam.getIslegal());

            a2DataStatus.bj = (baseParam.getBj() == null) ? 0 : baseParam.getBj();
            a2DataStatus.bs = (baseParam.getBs() == null) ? 0 : baseParam.getBs();
            a2DataStatus.dym = (baseParam.getDym() == null) ? 0 : baseParam.getDym();


            a2DataVol.hsl = (baseParam.getHsl() == null) ? 0 : baseParam.getHsl();
            a2DataVol.smd = (baseParam.getSmd() == null) ? 0 : baseParam.getSmd();
            a2DataVol.qyb = (baseParam.getQyb() == null) ? 0 : baseParam.getQyb();
            a2DataVol.ymd = (baseParam.getYmd() == null) ? 0 : baseParam.getYmd();


        }



        //endregion
        //region step 2:
        AoidMsgValue.DiagnoseResult diagnoseResult = msg.getDiagnoseResult();
        AoidGkModel model = null;
        if (Objects.nonNull(diagnoseResult)) {

            aoidSinglegtYield.setEczdjg(diagnoseResult.getResult2());
            aoidSinglegtYield.setZdjg(diagnoseResult.getResult1());

            Integer result1 = Integer.parseInt(diagnoseResult.getResult1());
            if (result1 >= 1) {
                aoidSinglegtYield.setSgtIsLegal(1);
            } else {
                aoidSinglegtYield.setSgtIsLegal(0);
            }
            model = aoidGkModelService.getGKModelByResultType(diagnoseResult.getResult2());
        }
        AoidSinglewellConfig effectStrockModel = aoidSinglewellConfigService.getConfigOneObjByID(1);


        Double[][] bgt = null;
        Double[][] sgt = baseParam.getSgt() == null ? null : SGTUtil.encodeToDoubleArray(baseParam.getSgt());
        double areaReal = CardAreaAlgorithm.calArea(sgt);
        if (Objects.nonNull(baseParam) && Objects.nonNull(diagnoseResult)) {
            bgt = calPumpCard.cal_bgt(
                    sgt,
                    baseParam.getS(),
                    baseParam.getIslegal(),
                    1.0,
                    diagnoseResult.getResult2());
        }


        CalDiagramProduction.CalProductionResult production = new CalDiagramProduction.CalProductionResult();


        if (finalCoefficient > 9) {
            finalCoefficientEnd = 1.0;
        } else {
            finalCoefficientEnd = finalCoefficient;
        }


        if (model != null) {
            finalCoefficientEndValue = model.getTriggerFlag().equals("0") ? finalCoefficientEnd : finalCoefficientEnd * model.getGkxs();
        } else {
            finalCoefficientEndValue = 1.0;
        }


        boolean checked = checkInputDataBeforeCalDiagramProductionEnd(production, a2DataStatus, a2DataVol, bgt, baseParam, diagnoseResult, model, effectStrockModel, areaReal);
        aoidSinglegtYield.setCalIsNormal(checked ? 1 : 0);
        if (checked) {
            production = calDiagramProduction.calProduction(
                    sgt,
                    bgt,
                    baseParam.getS(),
                    baseParam.getN(),
                    diagnoseResult.getResult2(),
                    baseParam.getBj(),
                    baseParam.getBs(),
                    baseParam.getHsl(),
                    baseParam.getSmd(),
                    baseParam.getYmd(),
                    baseParam.getQyb(),
                    baseParam.getDym(),
                    finalCoefficientEndValue,
                    effectStrockModel
            );
        }

        //endregion

        //region step 3:


        if (production.rcyl1 == null) {
            LiqProdDaily = 0.0;
        } else {
            LiqProdDaily = production.rcyl1;
        }


        return LiqProdDaily;


        //endregion
    }

    public class ProDataForCalProductionValue {

        private Double bj;

        private Double bs;


        private Double hsl;

        private Double qyb;

        private Double dym;

        private Double ymd;

        private Double smd;


    }


    //稠油检测
    private boolean checkInputDataBeforeCalDiagramProductionHeavy_Oil(CalDiagramProductionCopy.CalProductionResult production, ProDataForCalProduction a2data, ProDataForCalProduction a2dataVol, Double[][] bgt, AoidMsg.BaseParam dcbp, AoidMsg.DiagnoseResult diagnoseResult, AoidGkHeavyModel model) {
        production.remark = "";
        if (bgt == null || bgt.length == 0) production.appendRemark("泵功图无法计算");


        if (Objects.isNull(dcbp)) production.appendRemark("缺失功图参数");
        else {
            if (dcbp.getIslegal() != 1) {
                if (Objects.nonNull(diagnoseResult) && Objects.nonNull(diagnoseResult.getResult2()) && !diagnoseResult.getResult2().isEmpty())
                    production.appendRemark("功图不合法:" + diagnoseResult.getResult2());
                else production.appendRemark("功图不合法");
            }

            if (Objects.isNull(dcbp.getN())) production.appendRemark("缺失冲次");
            else if (dcbp.getN() == 0) production.appendRemark("冲次为0");


            if (Objects.isNull(dcbp.getS())) production.appendRemark("缺失冲程");
            else if (dcbp.getS() == 0) production.appendRemark("冲程为0");

        }

        if (Objects.isNull(a2data)) production.appendRemark("缺失井状态日数据");
        else {
            if (Objects.isNull(a2data.getBj())) production.appendRemark("缺失泵径");
            if (Objects.isNull(a2data.getBs())) production.appendRemark("缺失泵深");
            if (Objects.isNull(a2data.getDym())) production.appendRemark("缺失动液面");
        }


        if (Objects.isNull(a2dataVol)) production.appendRemark("缺失井产量日数据");
        else {
            if (Objects.isNull(a2dataVol.getHsl())) production.appendRemark("缺失含水率");
            if (Objects.isNull(a2dataVol.getSmd())) production.appendRemark("缺失水比重");
            if (Objects.isNull(a2dataVol.getQyb())) production.appendRemark("缺失气油比");
            if (Objects.isNull(a2dataVol.getYmd())) production.appendRemark("缺失油比重");
        }


//        if (Objects.isNull(model) || Objects.isNull(model.getModelparam()))
//            production.appendRemark("缺失工况对应计量模型");

        // if (Objects.isNull(effectStrockModel)) production.appendRemark("缺失有效冲程计算模型");

        if (Objects.isNull(diagnoseResult) || Objects.isNull(diagnoseResult.getResult1())
                || Objects.isNull(diagnoseResult.getResult2()) || diagnoseResult.getResult1().isEmpty()
                || diagnoseResult.getResult2().isEmpty()) production.appendRemark("缺失诊断结果数据");

        if (!production.remark.isEmpty())
            return false;
        return true;
    }

    //稠油量液算法
    public void cal2(AoidMsg msg) throws InstantiationException, IllegalAccessException, InvocationTargetException, NoSuchMethodException {

        ProDataForCalProduction a2DataStatus = null;
        ProDataForCalProduction a2DataVol = null;
        ProDataForCalProduction WellAttrdata = null;
        ProDataForCalProduction wellMeterteam = null;
        CalDiagramProductionCopy algorithm_new = new CalDiagramProductionCopy();
        List<Double[]> bgt_correct;
        double jlj = 0;
        boolean isPumpAndGush;
        double impulse = 1;//默认冲次
        double viscosity = 5631.1; //默认井口粘度
        //double pumpDepth = 1599.6;
        AoidSinglegtYield aoidSinglegtYield = new AoidSinglegtYield();

        //region step 1:
        AoidMsg.BaseParam baseParam = msg.getBaseParam();
        if (Objects.nonNull(baseParam) && Objects.nonNull(baseParam.getProdDate()) &&
                Objects.nonNull(baseParam.getWellId())) {
            aoidSinglegtYield.setWellId(baseParam.getWellId());
            aoidSinglegtYield.setWellCommonName(baseParam.getWellname());
            aoidSinglegtYield.setProdDate(baseParam.getProdDate());
            aoidSinglegtYield.setStroke(baseParam.getS());
            aoidSinglegtYield.setFrequence(baseParam.getN());
            aoidSinglegtYield.setSxzh(baseParam.getLMax());
            aoidSinglegtYield.setXxzh(baseParam.getLMin());
            aoidSinglegtYield.setSgt(baseParam.getSgt());
            aoidSinglegtYield.setSgtIsLegal(baseParam.getIslegal());
            String a2Date = baseParam.getProdDate().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
            String a2dataStr = baseDataClient.getA2StatusDataForCalProduction(baseParam.getWellId(), a2Date);
            a2DataStatus = (ProDataForCalProduction) JSONObject.parseObject(a2dataStr, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
            String a2dataStrVol = baseDataClient.getA2VolDataForCalProduction(baseParam.getWellId(), a2Date);
            a2DataVol = (ProDataForCalProduction) JSONObject.parseObject(a2dataStrVol, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
            String WellAttr = baseDataClient.selectOneByWellId(baseParam.getWellId());
            WellAttrdata = (ProDataForCalProduction) JSONObject.parseObject(WellAttr, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
            if (WellAttrdata == null) WellAttrdata = new ProDataForCalProduction().setPzxs(1d);
            else if (WellAttrdata.getPzxs() == 0) WellAttrdata.setPzxs(1d);
            String wellStrMeterteamdate = baseParam.getProdDate().minusDays(1).format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
            String wellStrMeterteam = baseDataClient.getWellMeterTeamForCalProduction(baseParam.getWellId(), wellStrMeterteamdate);
            wellMeterteam = (ProDataForCalProduction) JSONObject.parseObject(wellStrMeterteam, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
        }

        //endregion

        //region step 2:
        AoidMsg.DiagnoseResult diagnoseResult = msg.getDiagnoseResult();
        AoidGkHeavyModel model = null;
        if (Objects.nonNull(diagnoseResult)) {

            aoidSinglegtYield.setEczdjg(diagnoseResult.getResult2());
            aoidSinglegtYield.setZdjg(diagnoseResult.getResult1());

            Integer result1 = Integer.parseInt(diagnoseResult.getResult1());
            if (result1 >= 1) {
                aoidSinglegtYield.setSgtIsLegal(1);
            } else {
                aoidSinglegtYield.setSgtIsLegal(0);
            }

            model = aoidGkHeavyModelService.getGKModel_HeavyByResultType(diagnoseResult.getResult2());
        }
        if ("喷抽".equals(diagnoseResult.getResult2())) {
            isPumpAndGush = true;
        } else {
            isPumpAndGush = false;
        }
        Double[][] bgt = null;
        List<Double[]> sgt_correct = SGTUtil.encodeToView(baseParam.getSgt());
        CalPumpCardCopy calPumpCard = new CalPumpCardCopy();
        if (Objects.nonNull(baseParam) && Objects.nonNull(diagnoseResult)) {
            bgt = calPumpCard.cal_bgt(
                    sgt_correct.toArray(new Double[][]{}),
                    baseParam.getS(),
                    baseParam.getSMin(),
                    baseParam.getIslegal(),
                    impulse,//TODO:冲次影响阻尼计算 暂时默认传入1
                    isPumpAndGush,
                    a2DataStatus.getBs(),
                    WellAttrdata.getNd(), //TODO: 传入真实的原油粘度数据
                    null);
        }
        bgt_correct = new ArrayList<>();
        if (bgt != null) {
            for (int i = 0; i < bgt.length; i++) {
                bgt_correct.add(new Double[]{bgt[i][0], bgt[i][1]});
            }
        }

        Integer modelparamValue = 0;
        if (Objects.isNull(model) || Objects.isNull(model.getModelparam())) {
            modelparamValue = 1;
        } else {
            modelparamValue = model.getModelparam();
        }


        CalDiagramProductionCopy.CalProductionResult production = new CalDiagramProductionCopy.CalProductionResult();
        boolean checked = checkInputDataBeforeCalDiagramProductionHeavy_Oil(production, a2DataStatus, a2DataVol, bgt, baseParam, diagnoseResult, model);


        aoidSinglegtYield.setCalIsNormal(checked ? 1 : 0);
        if (checked) {
            production = algorithm_new.calProduction(
                    bgt_correct.toArray(new Double[][]{}),
                    baseParam.getS(),
                    impulse,
                    isPumpAndGush,
                    a2DataStatus.getBj(),
                    a2DataStatus.getBs(),
                    a2DataVol.getHsl(),
                    a2DataVol.getSmd(),
                    a2DataVol.getYmd(),
                    a2DataVol.getQyb(),
                    WellAttrdata.getPzxs(),
                    modelparamValue
            );
        }

        //endregion

        //region step 3:
        if (a2DataStatus != null) {
            aoidSinglegtYield.setBj(a2DataStatus.getBj());
            aoidSinglegtYield.setBs(a2DataStatus.getBs());
            if (Objects.nonNull(a2DataStatus.getBs()) && Objects.nonNull(a2DataStatus.getDym()))
                aoidSinglegtYield.setCmd(Math.round((a2DataStatus.getBs().doubleValue() - a2DataStatus.getDym().doubleValue()) * 10) / 10d);
            aoidSinglegtYield.setYzzj(a2DataStatus.getBj());
            aoidSinglegtYield.setHy(a2DataStatus.getBackPres());
            aoidSinglegtYield.setYy(a2DataStatus.getTubingPres());
            aoidSinglegtYield.setTy(a2DataStatus.getCasingPres());
            aoidSinglegtYield.setA2Dym(a2DataStatus.getDym());
        }

        if (wellMeterteam != null) {
            aoidSinglegtYield.setTestLiquVolDaily(wellMeterteam.getTlvd());
        } else {
            aoidSinglegtYield.setTestLiquVolDaily(jlj);
        }

        if (a2DataVol != null) {
            aoidSinglegtYield.setHsl(a2DataVol.getHsl());
            aoidSinglegtYield.setSmd(a2DataVol.getSmd());
            aoidSinglegtYield.setYmd(a2DataVol.getYmd());
            aoidSinglegtYield.setQyb(a2DataVol.getQyb());
            aoidSinglegtYield.setA2LiqProdDaily(a2DataVol.getLiqProdDaily());
            aoidSinglegtYield.setA2OilProdDaily(a2DataVol.getOilProdDaily());
            aoidSinglegtYield.setA2WaterProdDaily(a2DataVol.getWaterProdDaily());
            aoidSinglegtYield.setA2GasProdDaily(a2DataVol.getGasProdDaily());
            aoidSinglegtYield.setA2WaterCut(a2DataVol.getHsl());
            aoidSinglegtYield.setA2Remark(a2DataVol.getRemarks());
            aoidSinglegtYield.setA2ProdTime(a2DataVol.getProdTime());
        }


        if (bgt != null && bgt.length > 0) {
            aoidSinglegtYield.setBgt(SGTUtil.encodeToString(bgt));
        }
        if (production != null) {
            aoidSinglegtYield.setRemark(production.remark);

            aoidSinglegtYield.setLiqProdDaily(production.rcyl);
            aoidSinglegtYield.setCreateTime(LocalDateTime.now());//创建时间
            aoidSinglegtYield.setOilProdDaily(production.rcyl1);
            aoidSinglegtYield.setGasProdDaily(production.rcql);
            aoidSinglegtYield.setDym(production.dym
            );
            aoidSinglegtYield.setBx(production.bx);
            //aoidSinglegtYield.setFlag();
            //aoidSinglegtYield.setBdxs();
            aoidSinglegtYield.setLlpl(production.llpl);
            aoidSinglegtYield.setBdxs(WellAttrdata.getPzxs());//标定系数
            aoidSinglegtYield.setZcc(production.zcc);
            aoidSinglegtYield.setSjcc(production.sjcc);
            aoidSinglegtYield.setYxcc(production.yxcc);
            aoidSinglegtYield.setCcss(production.ccss);
            aoidSinglegtYield.setLsss(production.lsss);
            aoidSinglegtYield.setGyss(production.gyss);
            aoidSinglegtYield.setWaterProdDaily(production.rcsl);
            aoidSinglegtYield.setStrokeRatio(production.l_StrokeRatio);
        }
        aoidSinglegtYield.setScsj(24d);


        if (!aoidSinglegtYieldService.update(aoidSinglegtYield, new LambdaUpdateWrapper<AoidSinglegtYield>()
                .eq(AoidSinglegtYield::getWellId, aoidSinglegtYield.getWellId())
                .eq(AoidSinglegtYield::getProdDate, aoidSinglegtYield.getProdDate())))
            aoidSinglegtYieldService.save(aoidSinglegtYield);

        //endregion
    }
}
